c $Header: /usr/people/flittner/radtran/flatpsv/src/actflux.f,v 1.14 1999/08/16 18:57:14 flittner Exp flittner $
c ---------------------------------------------------------------------

      real*8 function actflux(lev,esi0,dmu,nz,nlos,np,ndownlos,
     &idflag)

C CALCULATE ACTINIC FLUX ON THE ZENITH AT LEVEL LEV
C ESI0 IS THE INTENSITY DISTRIBUTION AT THIS LEVEL
 
      implicit none
      include 'consts.cmn'
      include 'param.inc'
c variables that are passed
      integer lev,nz,nlos,np,idflag,ndownlos
      real*8 esi0(4,nfi,mlos,maxnz),dmu(mlos)
c variables that are local
      integer i,k,is,ie
      real*8 sum,const
C    LEV=1 ; Then at the top of the atmosphere and is the upward case.
C    LEV=NZ; Then at the surface and is the downward case.
C The i counter variable in do loop represents theta direction.
C The k counter variable is for phi.
C The constant const is used to incorporate the symmetry used.

      sum=0.0
      if(idflag.eq.0)then
        is=1
        ie=ndownlos
      else
        is=1+ndownlos
        ie=nlos
      endif
      if(np.gt.1)then
        do i=is,ie
           const=dmu(i)*df
           sum=sum+(esi0(1,1,i,lev)+esi0(2,1,i,lev))*const
           sum=sum+(esi0(1,nfi,i,lev)+esi0(2,nfi,i,lev))*const
           const=dmu(i)*df*2.0d0
           do k=2,nfi-1
              sum=sum+const*(esi0(1,k,i,lev)+esi0(2,k,i,lev))
           enddo
        enddo
      else
        do i=is,ie
           const=dmu(i)*df
           sum=sum+esi0(1,1,i,lev)*const
           sum=sum+esi0(1,nfi,i,lev)*const
           const=dmu(i)*df*2.0d0
           do k=2,nfi-1
              sum=sum+const*esi0(1,k,i,lev)
           enddo
        enddo
      endif
      actflux=sum
      return
      end
c ---------------------------------------------------------------------
