clear all;
close all;

%CALCULATION OF IRAYLEIGH 354 nm

[s354]=sprintf('/mnt/home/hiren.jethva/OMILUT/RAYUVLT/w0.3540.s00.0.top');
[s388]=sprintf('/mnt/home/hiren.jethva/OMILUT/RAYUVLT/w0.3880.s00.0.top');

fid1=fopen(s354);
fid2=fopen(s388);

%READING HEADER INFORMATION
for p=1:13
     line1=fgetl(fid1);
     line2=fgetl(fid2);
end
   
             
for q=14:14
    line1=fgetl(fid1);
    line2=fgetl(fid2);
	[Rdata354] = sscanf(line1,'%f');
    [Rdata388] = sscanf(line2,'%f');
end








%CALCULATION OF ITOTAL (IAERO)
aod1='00';aod2='01';aod3='05';aod4='10';aod5='25';aod6='40';aod7='60';
cod1='00';cod2='20';cod3='50';cod4='10';

count=1;

for i=1:7   %AEROSOL OPTICAL DEPTH LOOP
        
    
    if(i==1)
        straod=aod1;
    elseif(i==2)
        straod=aod2;
    elseif(i==3)
        straod=aod3;
    elseif(i==4)
        straod=aod4;
    elseif(i==5)
        straod=aod5;
    elseif(i==6)
        straod=aod6;
    elseif(i==7)
        straod=aod7;
    end
    
    
    
    for j=1:4    %CLOUD OPTICAL DEPTH LOOP
        
        if(j==1)
            strcod=cod1;
        elseif(j==2)
            strcod=cod2;
        elseif(j==3)
            strcod=cod3;
        elseif(j==4)
            strcod=cod4;
        end
        
        
        
        
        xref=0.05;           
                       
        

       [s354]=sprintf('/mnt/home/hiren.jethva/ARIZONA_RT_CloudAerosols/ARIZONA_CODE/OperationalLUT/PresLev1000/Height3p0/SSA0888_%s_%s/Azi1/w0.3540.s00.0.top',straod,strcod);
       [s388]=sprintf('/mnt/home/hiren.jethva/ARIZONA_RT_CloudAerosols/ARIZONA_CODE/OperationalLUT/PresLev1000/Height3p0/SSA0888_%s_%s/Azi1/w0.3880.s00.0.top',straod,strcod);
       

                
                
        fid1=fopen(s354);
        fid2=fopen(s388);
                
                
                
        %READING HEADER INFORMATION
        for p=1:13
            line1=fgetl(fid1);
            line2=fgetl(fid2);
        end
                
                
                
                for q=14:14
                    line1=fgetl(fid1);
                    line2=fgetl(fid2);
                 
                    [data354] = sscanf(line1,'%f');
                    [data388] = sscanf(line2,'%f');
                    
                    
                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    %CALCULATE THE EQUIVALENT REFLECTIVITY AT 388 NM (R3880)

                    R388=(data388(6)-Rdata388(5))/(Rdata388(7)+(Rdata388(8)*(data388(6)-Rdata388(5))));
                    
                    
                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    %CALCULATE I354 at 354 NM (CALCULATED)
                    I354calc=Rdata354(5)+R388*Rdata354(7)/(1-Rdata354(8)*R388);
                    

                    %CALCULATE AEROSOL INDEX
                    I388(i,j)=data388(6)/pi;
                    R3881(i,j)=R388;
                    AI(i,j)=-100*log10(data354(6)./I354calc);       
		    RAT(i,j)=data354(6)/data388(6);
                    
                   
                    count=count+1;

                    data354=[];data388=[];
                    ILAMBDA354=[];ILAMBDA388=[];
                end
                
                
                fclose(fid1);
                fclose(fid2);
    
    end
            
end
        

figure(1)
for i=1:7
    for j=1:1
        plot(I388(i,:),RAT(i,:),'bO-','linewi',2)
        hold on
        grid on
    end
end

xlabel('I_{388}','fontsize',16)
ylabel('UV AI','fontsize',16)

figure(2)
for i=1:7
    for j=1:1
        plot(R3881(i,:),AI(i,:),'bO-','linewi',2)
        hold on
        grid on
    end
end

xlabel('R_{388}','fontsize',16)
ylabel('UV AI','fontsize',16)