clear all;
close all;

%CALCULATION OF IRAYLEIGH 354 nm

[s354]=sprintf('/mnt/home/hiren.jethva/ARIZONA_RT_DUST/ARIZONA_CODE/OperationalLUT/PresLev1000/Height3p0/model1_00/Azi1/w0.3540.s20.0.top');
[s388]=sprintf('/mnt/home/hiren.jethva/ARIZONA_RT_DUST/ARIZONA_CODE/OperationalLUT/PresLev1000/Height3p0/model1_00/Azi1/w0.3880.s20.0.top');


fid1=fopen(s354);
fid2=fopen(s388);

%READING HEADER INFORMATION
for p=1:13
     line1=fgetl(fid1);
     line2=fgetl(fid2);
end
   
             
for q=14:14
    line1=fgetl(fid1);
    line2=fgetl(fid2);
	[Rdata354] = sscanf(line1,'%f');
    [Rdata388] = sscanf(line2,'%f');
end





%CALCULATION OF ITOTAL (IAERO)
aod1='00';aod2='01';aod3='05';aod4='10';aod5='25';aod6='40';aod7='60';

count=1;
    
for i=1:6    %AEROSOL OPTICAL DEPTH LOOP

    if(i==1)
        straod=aod1;
    elseif(i==2)
        straod=aod2;
    elseif(i==3)
        straod=aod3;
    elseif(i==4)
        straod=aod4;
    elseif(i==5)
        straod=aod5;
    elseif(i==6)
        straod=aod6;
    elseif(i==7)
        straod=aod7;
    end
        
    
   [s354]=sprintf('/mnt/home/hiren.jethva/ARIZONA_RT_DUST/ARIZONA_CODE/OperationalLUT/PresLev1000/Height3p0/model1_%s/Azi1/w0.3540.s20.0.top',straod);
   [s388]=sprintf('/mnt/home/hiren.jethva/ARIZONA_RT_DUST/ARIZONA_CODE/OperationalLUT/PresLev1000/Height3p0/model1_%s/Azi1/w0.3880.s20.0.top',straod);
   
       
    fid1=fopen(s354);
    fid2=fopen(s388);
                
                
                
    %READING HEADER INFORMATION
    for p=1:13
        line1=fgetl(fid1);
        line2=fgetl(fid2);
    end
                
    for q=14:14
        line1=fgetl(fid1);
        line2=fgetl(fid2);
                 
        [data354] = sscanf(line1,'%f');
        [data388] = sscanf(line2,'%f');
                    
                    
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %CALCULATE THE EQUIVALENT REFLECTIVITY AT 388 NM (R3880)

        R388=(data388(6)-Rdata388(5))/(Rdata388(7)+(Rdata388(8)*(data388(6)-Rdata388(5))));
                    

        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %CALCULATE I354 at 354 NM (CALCULATED)
        I354calc=Rdata354(5)+R388*Rdata354(7)/(1-Rdata354(8)*R388);
                    

        %CALCULATE AEROSOL INDEX
        I388(i)=data388(6)/pi;
        R3881(i)=R388;
        AI(i)=-100*log10(data354(6)./I354calc);       
        RAT(i)=data354(6)/data388(6);
                    
                   
        count=count+1;

        data354=[];data388=[];
        ILAMBDA354=[];ILAMBDA388=[];
    end
                
                
        fclose(fid1);
        fclose(fid2);

    
end
aod=[0.0,0.1,0.5,1.0,2.5,4.0];

plot(aod,AI,'rO-','linewid',3')
hold on
grid on
xlabel('Aerosol Optical Depth','fontsize',16)
ylabel('UV AI','fontsize',16)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%SMOKE MODEL
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ai=[];
%CALCULATION OF IRAYLEIGH 354 nm

[s354]=sprintf('/mnt/home/hiren.jethva/ARIZONA_RT_NEWLUT_SPECTRALDEP/ARIZONA_CODE/OperationalLUT/PresLev1000/Height3p0/SSA0888_00/Azi1/w0.3540.s20.0.top');
[s388]=sprintf('/mnt/home/hiren.jethva/ARIZONA_RT_NEWLUT_SPECTRALDEP/ARIZONA_CODE/OperationalLUT/PresLev1000/Height3p0/SSA0888_00/Azi1/w0.3880.s20.0.top');

fid1=fopen(s354);
fid2=fopen(s388);

%READING HEADER INFORMATION
for p=1:13
     line1=fgetl(fid1);
     line2=fgetl(fid2);
end
   
             
for q=14:14
    line1=fgetl(fid1);
    line2=fgetl(fid2);
	[Rdata354] = sscanf(line1,'%f');
    [Rdata388] = sscanf(line2,'%f');
end





%CALCULATION OF ITOTAL (IAERO)
aod1='00';aod2='01';aod3='05';aod4='10';aod5='25';aod6='40';aod7='60';

count=1;
    
for i=1:6    %AEROSOL OPTICAL DEPTH LOOP

    if(i==1)
        straod=aod1;
    elseif(i==2)
        straod=aod2;
    elseif(i==3)
        straod=aod3;
    elseif(i==4)
        straod=aod4;
    elseif(i==5)
        straod=aod5;
    elseif(i==6)
        straod=aod6;
    elseif(i==7)
        straod=aod7;
    end
        
    
   [s354]=sprintf('/mnt/home/hiren.jethva/ARIZONA_RT_NEWLUT_SPECTRALDEP/ARIZONA_CODE/OperationalLUT/PresLev1000/Height3p0/SSA1000_%s/Azi1/w0.3540.s20.0.top',straod);
   [s388]=sprintf('/mnt/home/hiren.jethva/ARIZONA_RT_NEWLUT_SPECTRALDEP/ARIZONA_CODE/OperationalLUT/PresLev1000/Height3p0/SSA1000_%s/Azi1/w0.3880.s20.0.top',straod);   
       
    fid1=fopen(s354);
    fid2=fopen(s388);
                
                
                
    %READING HEADER INFORMATION
    for p=1:13
        line1=fgetl(fid1);
        line2=fgetl(fid2);
    end
                
    for q=14:14
        line1=fgetl(fid1);
        line2=fgetl(fid2);
                 
        [data354] = sscanf(line1,'%f');
        [data388] = sscanf(line2,'%f');
                    
                    
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %CALCULATE THE EQUIVALENT REFLECTIVITY AT 388 NM (R3880)

        R388=(data388(6)-Rdata388(5))/(Rdata388(7)+(Rdata388(8)*(data388(6)-Rdata388(5))));
                    

        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %CALCULATE I354 at 354 NM (CALCULATED)
        I354calc=Rdata354(5)+R388*Rdata354(7)/(1-Rdata354(8)*R388);
                    

        %CALCULATE AEROSOL INDEX
        I388(i)=data388(6)/pi;
        R3881(i)=R388;
        AI(i)=-100*log10(data354(6)./I354calc);       
        RAT(i)=data354(6)/data388(6);
                    
                   
        count=count+1;

        data354=[];data388=[];
        ILAMBDA354=[];ILAMBDA388=[];
    end
                
                
        fclose(fid1);
        fclose(fid2);

    
end
aod=[0.0,0.1,0.5,1.0,2.5,4.0];

plot(aod,AI,'bO-','linewid',3')
hold on
grid on
xlabel('Aerosol Optical Depth','fontsize',16)
ylabel('UV AI','fontsize',16)




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%SPECIAL CASE SULPHATE MODEL
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ai=[];
%CALCULATION OF IRAYLEIGH 354 nm

[s354]=sprintf('/mnt/home/hiren.jethva/ARIZONA_RT_SULPHATE/ARIZONA_CODE/OperationalLUT/PresLev1000/SpecialCase/IND7_00/w0.3540.s20.0.top');
[s388]=sprintf('/mnt/home/hiren.jethva/ARIZONA_RT_SULPHATE/ARIZONA_CODE/OperationalLUT/PresLev1000/SpecialCase/IND7_00/w0.3880.s20.0.top');


fid1=fopen(s354);
fid2=fopen(s388);

%READING HEADER INFORMATION
for p=1:13
     line1=fgetl(fid1);
     line2=fgetl(fid2);
end
   
             
for q=14:14
    line1=fgetl(fid1);
    line2=fgetl(fid2);
	[Rdata354] = sscanf(line1,'%f');
    [Rdata388] = sscanf(line2,'%f');
end





%CALCULATION OF ITOTAL (IAERO)
aod1='00';aod2='01';aod3='05';aod4='10';aod5='25';aod6='40';aod7='60';

count=1;
    
for i=1:6    %AEROSOL OPTICAL DEPTH LOOP

    if(i==1)
        straod=aod1;
    elseif(i==2)
        straod=aod2;
    elseif(i==3)
        straod=aod3;
    elseif(i==4)
        straod=aod4;
    elseif(i==5)
        straod=aod5;
    elseif(i==6)
        straod=aod6;
    elseif(i==7)
        straod=aod7;
    end
        
    [s354]=sprintf('/mnt/home/hiren.jethva/ARIZONA_RT_SULPHATE/ARIZONA_CODE/OperationalLUT/PresLev1000/SpecialCase/IND7_%s/w0.3540.s20.0.top',straod);
    [s388]=sprintf('/mnt/home/hiren.jethva/ARIZONA_RT_SULPHATE/ARIZONA_CODE/OperationalLUT/PresLev1000/SpecialCase/IND7_%s/w0.3880.s20.0.top',straod);
    
      
    fid1=fopen(s354);
    fid2=fopen(s388);
                
                
                
    %READING HEADER INFORMATION
    for p=1:13
        line1=fgetl(fid1);
        line2=fgetl(fid2);
    end
                
    for q=14:14
        line1=fgetl(fid1);
        line2=fgetl(fid2);
                 
        [data354] = sscanf(line1,'%f');
        [data388] = sscanf(line2,'%f');
                    
                    
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %CALCULATE THE EQUIVALENT REFLECTIVITY AT 388 NM (R3880)

        R388=(data388(6)-Rdata388(5))/(Rdata388(7)+(Rdata388(8)*(data388(6)-Rdata388(5))));
                    

        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %CALCULATE I354 at 354 NM (CALCULATED)
        I354calc=Rdata354(5)+R388*Rdata354(7)/(1-Rdata354(8)*R388);
                    

        %CALCULATE AEROSOL INDEX
        I388(i)=data388(6)/pi;
        R3881(i)=R388;
        AI(i)=-100*log10(data354(6)./I354calc);       
        RAT(i)=data354(6)/data388(6);
                    
                   
        count=count+1;

        data354=[];data388=[];
        ILAMBDA354=[];ILAMBDA388=[];
    end
                
                
        fclose(fid1);
        fclose(fid2);

    
end
aod=[0.0,0.1,0.5,1.0,2.5,4.0];

plot(aod,AI,'kO-','linewid',3')
hold on
grid on
xlabel('Aerosol Optical Depth','fontsize',16)
ylabel('UV AI','fontsize',16)