c $Header: /usr/people/flittner/radtran/flatpsv/src/aureolep.f,v 1.14 1999/08/16 18:59:08 flittner Exp flittner $
c program to compute the aureole given that the radiative transfer
c equation has been solved already.
c
      subroutine aureolep(ivlev,thetapmin,thetapmax,dthetap,
     &nlos,np,nz,isfc,npass,ndownlos,
     &aniso,linterpms,
     &Tfine,Tfinec,omega0,omega0c,
     &QS,QSc,deltmu,dmu,dt,sun,cosn,sinn,costh,sinth,thd,trans,
     &wavel,fmatrx,rmatrx,cmatrx,gamma,pa,pal,wa,wr,wc,refl,
     &sflux,Fo,pasi0,Fu,fluxfactor,Sbar,esi0,esing0,esi0r,rsfc0,rsfc,
     &thdbnd,phibnd)
c
c last modified: Nov. 22, 1996
c purpose: eliminate the passage of the logicals for the atmosphere
c components. 
c
c last modified: May 5, 1997...def
c purpose: delete Ig and change use of refl.
c
c last modified: May 7, 1997...def
c purpose: pass theta and phi boundaries (thdbnd,phibnd).
c          Also delete use of cpr,cpf,cpc,cpr0,cpf0,cpc0
c
c last modified: Dec. 30, 1997...def
c purpose: Increase second dimension of Tfine from 4 to 7 so that can
c          use phase functions created by tmatrix program and liou.
c
      implicit none
      include 'consts.cmn'
      include 'param.inc'
      include 'catmdata.cmn'
c 
c passed in
      integer ivlev,nlos,np,nz,isfc,npass,ndownlos
      logical aniso,linterpms
      real*8 thetapmin,thetapmax,dthetap,sun,Fo
      real*8 gamma,rmatrx(4,4,nfi,mlos,mlos)
      real*8 wr(maxnlayr)
      real*8 omega0,Tfine(nan,7),fmatrx(4,4,nfi,mlos,mlos),QS
      real*8 wa(maxnlayr)
      real*8 omega0c,Tfinec(nan,7),cmatrx(4,4,nfi,mlos,mlos),QSc
      real*8 wc(maxnlayr)
      real*8 deltmu(mlos),dmu(mlos),dt(maxnlayr),cosn(nfi),sinn(nfi)
      real*8 costh(mlos),sinth(mlos),thd(mlos),trans(mlos,maxnz)
      real*8 wavel,pa(maxnz),pal(mlos,maxnz),refl
      real*8 sflux(4),pasi0,Fu,fluxfactor,Sbar
      real*8 esi0(4,nfi,mlos,maxnz),esing0(4,nfi,mlos,maxnz)
      real*8 esi0r(4,mlos,maxnz)
      real*8 rsfc0(4,4,nfi,mlos),rsfc(4,4,nfi,mlos,mlos)
      real*8 thdbnd(mlos+1),phibnd(nfi+1)
c local
      integer maxnphi,maxnthetap,nphi,nthetap
      parameter (maxnphi=20,maxnthetap=110)
      real*8 aurtht(maxnphi),aurphi(maxnphi),delphi,thetap(maxnthetap)
      real*8 Itotal(maxnphi,maxnthetap),Isingle(maxnphi,maxnthetap)
      real*8 direct,sunomega,vtheta,vphi
      real*8 Ifwdtot,Ifwdsig,center
      real*8 Tbar(4)
      real*8 vout(4,maxnz),vsing0(4,maxnz)
      logical gnd,dodirect,avgall
      integer i,j
c local but not passed
      real*8 Tbb
c***********************************************************************
      avgall=.TRUE.
c
c direct transmission to the surface
      direct=dexp(-pasi0)
c solid angle of the sun
      sunomega=2.0d0*pi*(1.0d0-dcos(0.25d0*dr))
c compute forward peak intensity
      vtheta=sun
      center=sun
      vphi=0.0d0
      gnd=.TRUE.
      ivlev=nz
c
      write(61,1006)center,center
      write(64,1006)center,center
c23456789012345678901234567890123456789012345678901234567890123456789012
1006  format(1x,
     &'The intensity values for the aureole are: (Values are at a ',
     &'constant aureole',/,
     &' angle from the sun with the first value in the',
     &' solar plane at an',/,' angle of',f6.2,' + the aureole angle',
     &' and the last value is also in',/,' the solar plane at an angle',
     &' of',f6.2,' - the aureole angle.)')
c compute the diffuse component to of the radiance in the forward direction
c with view
      dodirect=.TRUE.
c solve for Intensity in direction vtheta,vphi at level ivlev for zero
c surface reflectance case using esi0 solution.
      call view(ivlev,nlos,np,nz,
     &aniso,avgall,dodirect,
     &cosn,costh,deltmu,dmu,dt,esi0,
     &fmatrx,gamma,omega0,pa,pal,wa,wr,QS,refl,
     &rmatrx,sflux,wc,cmatrx,omega0c,QSc,Tfinec,
     &sinn,sinth,sun,Tfine,thd,trans,vtheta,vphi,wavel,
     &vsing0,vout,isfc,npass,ndownlos,esing0,linterpms,rsfc0,rsfc,
     &thdbnd,phibnd)
      Ifwdtot=vout(1,ivlev)
      Ifwdsig=vsing0(1,ivlev)
      if(np.gt.1)then
         Ifwdtot=Ifwdtot+vout(2,ivlev)
         Ifwdsig=Ifwdsig+vsing0(2,ivlev)
      endif
      if(isfc.le.0)then
        call viewr(ivlev,nlos,np,nz,dmu,esi0r,pal,trans,Fu,
     &vtheta,Tbar,wa,wr,wc,fmatrx,rmatrx,cmatrx,
     &thd,ndownlos,linterpms)
        Tbb=Tbar(1)
        if(np.gt.1)Tbb=Tbb+Tbar(2)
        Tbb=Tbb*fluxfactor
        Ifwdtot=Ifwdtot+Tbb*refl/(1.0d0-Sbar*refl)
      endif
c
      write(61,1005) 0.0,Ifwdtot,Ifwdsig
      write(64,1005) 0.0,Ifwdtot,Ifwdsig
1005  format(1x,'aureole angle=',f6.2,'(deg)',/,'Itotal =',
     &(1x,1Pe9.3),/,'Isingle=',(1x,1Pe9.3))
c
      if(npass.gt.0)then
        nthetap=int((thetapmax-thetapmin)/dthetap)+1
c
c set space around the sun to 30 deg.
        delphi=30.0d0
        dodirect=.TRUE.
        do 999 j=1,nthetap
          thetap(j)=thetapmin+dble(j-1)*dthetap
c transform to theta and phi in regular coordinate system
          call compang(center,thetap(j),delphi,aurtht,aurphi,
     &maxnphi,nphi)
          do 998 i=1,nphi
            vtheta=aurtht(i)
            vphi=aurphi(i)
c compute the diffuse radiance for this los
            call view(ivlev,nlos,np,nz,
     &aniso,avgall,dodirect,
     &cosn,costh,deltmu,dmu,dt,esi0,
     &fmatrx,gamma,omega0,pa,pal,wa,wr,QS,refl,
     &rmatrx,sflux,wc,cmatrx,omega0c,QSc,Tfinec,
     &sinn,sinth,sun,Tfine,thd,trans,vtheta,vphi,wavel,
     &vsing0,vout,isfc,npass,ndownlos,esing0,linterpms,rsfc0,rsfc,
     &thdbnd,phibnd)
            Itotal(i,j)=(vout(1,ivlev)+vout(2,ivlev))
            Isingle(i,j)=(vsing0(1,ivlev)+vsing0(2,ivlev))
            if(isfc.le.0)then
              call viewr(ivlev,nlos,np,nz,dmu,esi0r,pal,trans,Fu,
     &vtheta,Tbar,wa,wr,wc,fmatrx,rmatrx,cmatrx,
     &thd,ndownlos,linterpms)
              Tbb=Tbar(1)
              if(np.gt.1)Tbb=Tbb+Tbar(2)
              Tbb=Tbb*fluxfactor
              Itotal(i,j)=Itotal(i,j)+Tbb*refl/(1.0d0-Sbar*refl)
            endif
998       continue
          write(6,*)'aureolep. done with thetap=',thetap(j)
          write(61,1010)thetap(j),(Itotal(i,j),i=1,nphi),
     &     (Isingle(i,j),i=1,nphi)
          write(64,1010)thetap(j),(Itotal(i,j),i=1,nphi),
     &     (Isingle(i,j),i=1,nphi)
1010	format(1x,'aureole angle=',f6.2,'(deg)',/,'Itotal =',
     &7(1x,1Pe9.3),/,'Isingle=',7(1x,1Pe9.3))
999     continue
c
c integrate the intensity to obtain fluxes due to total diffuse 
c radiation field
c
        call intaur(Itotal,maxnphi,maxnthetap,nphi,
     &     thetap,nthetap,delphi,Ifwdtot,sunomega,dr,
     &     dthetap,sun,Fo,direct)
c
        write(61,*)'  '
        write(61,*)'now for the single scattered values'
        write(61,*)'  '
        write(64,*)'  '
        write(64,*)'now for the single scattered values'
        write(64,*)'  '
c
c integrate the single scattered intensity to obtain fluxes due to 
c single scattered radiation.
c
        call intaur(Isingle,maxnphi,maxnthetap,nphi,
     &     thetap,nthetap,delphi,Ifwdsig,sunomega,dr,
     &     dthetap,sun,Fo,direct)
c
        call avgI(Itotal,maxnphi,maxnthetap,nphi,thetap,nthetap,Ifwdtot,
     &Isingle,Ifwdsig)
      endif
c
      return
      end
c
*********************************************************************
