c $Header: /home/loughman/flatpsv/src/brdf_av.f,v 1.2 2000/01/27 19:57:03 loughman Exp loughman $
c     Subroutine returns AVHRR-Dec. based BRDF
c      Interpolation and extrapolation to different solar azimuths is done
c	using ground data
c last modified: Sept. 15, 1998...def
c purpose: input the avhrr data via block data statement so don't have to mess with the
c input file avhrrdec.dat.
c
	subroutine brdf_av(mode,rho,thtinc,tht,phi)
c
        include 'avhrrdec.cmn'
	dimension afnrm(34),abnrm(34)
        integer ierr
c
	save /avhrrdec/
c
        if(.not.lnormed)then
c now data is the avhrrdec_blk.f
c         open(unit=10,file=cmodel2,status='old',err=ierr)
c         if(ierr.ne.0)then
c           write(6,*)'brdf-av. error opening file for data set'
c           write(6,*)cmodel2
c           mode=ierr
c           return
c         endif
c	 read(10,*) (itht0(i),i=1,46)
c	 do i=34,2,-1
c	  read(10,*) ith50(i),(rav50(j,i),j=1,46)
c	 enddo
c	 do i=2,34
c	  read(10,*) ith130(i),(rav130(j,i),j=1,46)
c	  ith130(i) = -ith130(i)
c	 enddo
c	 ith50(1) = -ith50(2)
c	 ith130(1) = -ith130(2)
c	 do j=1,46
c	  rav50(j,1) = rav130(j,2)
c	  rav130(j,1) = rav50(j,2)
c	 enddo
c   normalize data at sza = 75
	 do i=1,34
	  afnrm(i) = rav50(31,i)
	  abnrm(i) = rav130(31,i)
	 enddo
	 do j=1,46
	  do i=1,34
	   rav50(j,i) = rav50(j,i)/afnrm(i)/xnrm(j)
	   rav130(j,i) = rav130(j,i)/abnrm(i)/xnrm(j)
	  enddo
	 enddo
c         close(10)
c	 return
         lnormed=.TRUE.
	endif
c
        tht0=thtinc
c  find AVHRR sza bin first
	th = tht0 - itht0(1)
	if(th.lt.0.)then
         rho=1.0/acos(-1.0)
	 return
	endif
	isza1 = th + 1
	isza2 = th + 2
        if(isza2.gt.46)then
          isza1=45
          isza2=46
        endif
c  find AVHRR VWangle bin
	th = (tht+1.)/2.
	ith1 = 1 + th
	if(ith1.gt.33)ith1 = 33
	ith2 = 1 + ith1
c   Calculate ground-based value at sza=75
	rgnd = 0.
	do i=1,17
	 trm = pcf(i)
	 if(inphi(i).gt.0)trm = trm*(phi/10.)**inphi(i)
	 if(inth(i).gt.0)trm = trm*(tht/10.)**inth(i)
	 rgnd = rgnd + trm
	enddo
c
c Forward scattering
	if(phi.le.90.)then
c   calculate AVHRR-based correction to ground value
	  rcor = gcff(1)
	  if(tht.gt.0.)then
	   do i=2,5
	    rcor = rcor + gcff(i)*(tht/10.)**(i-1)
	   enddo
	  endif
c   determine SZA dependence (rel. to sza=75) based on AVHRR grid
	  rth1 = rav50(isza1,ith1) + (rav50(isza2,ith1)-rav50(isza1,ith1))
     &	         *(tht0-itht0(isza1))/float(itht0(isza2)-itht0(isza1))
	  rth2 = rav50(isza1,ith2) + (rav50(isza2,ith2)-rav50(isza1,ith2))
     &	         *(tht0-itht0(isza1))/float(itht0(isza2)-itht0(isza1))
          rav = rth1 + (rth2-rth1)*(tht-ith50(ith1))/
     &          float(ith50(ith2)-ith50(ith1))
c Backward scattering
	else
c   calculate AVHRR-based correction to ground value
	  rcor = gcfb(1)
	  if(tht.gt.0.)then
	   do i=2,5
	    rcor = rcor + gcfb(i)*(tht/10.)**(i-1)
	   enddo
	  endif
c   determine correction to sza=75 based on AVHRR grid
	rth1 = rav130(isza1,ith1)+(rav130(isza2,ith1)-rav130(isza1,ith1))
     &	         *(tht0-itht0(isza1))/(itht0(isza2)-itht0(isza1))
	rth2 = rav130(isza1,ith2)+(rav130(isza2,ith2)-rav130(isza1,ith2))
     &	         *(tht0-itht0(isza1))/(itht0(isza2)-itht0(isza1))
        rav = rth1 + (rth2-rth1)*(tht-ith130(ith1))/
     &          (ith130(ith2)-ith130(ith1))
	endif
	rho = rgnd*rcor*rav
	return
	end
