c $Header: /usr/people/flittner/radtran/flatpsv/src/caeromsmat.f,v 1.14 1999/08/16 18:57:14 flittner Exp flittner $
	subroutine caeromsmat(costh,sinth,cosn,sinn,wavel,dmu,const,
     &QS,thd,delphi,Tfine,cpf,fmatrx,omega0,np,nlos,avgall,useoldcpf,
     &g,iflag)
c
c calculate the aerosol multiple scattering matrix
c
c
c last modified: Nov. 18, 1996
c purpose: Add switch for Henyey-Greenstein phase function
c
c last modified: July 22, 1997...def
c purpose: Change the switch for HG phase function to flag for 
c          size dist (iflag).
c
c last modified: Dec. 30, 1997...def
c purpose: Increase second dimension of Tfine from 4 to 7 so that can
c          use phase functions created by tmatrix program and liou.
c
c last mod. Oct. 21, 1998...def
c purpose: change useoldcpf to integer
c
      implicit none
      include 'consts.cmn'
      include 'param.inc'
c passed in
      integer np,nlos,iflag,useoldcpf
      logical avgall
      real*8 costh(mlos),sinth(mlos),cosn(nfi),sinn(nfi),dmu(mlos)
      real*8 wavel,QS,thd(mlos),delphi,omega0,const
      real*8 Tfine(nan,7),cpf(mlos),fmatrx(4,4,nfi,mlos,mlos),g
c local
      integer i,ifwd,n,m,j,k
      real*8 amup,theta0,aconst
c
      do i=1,nlos
         amup=-costh(i)
         call Aerophase(amup,sinth(i),costh,sinth,cosn,sinn,nlos,
     &Tfine,wavel,QS,fmatrx,i,thd(i),thd,delphi,avgall,np,const,
     &g,iflag)
         theta0=thd(i)
         ifwd=i
         call compc(dmu,fmatrx,cpf(i),nlos,i,np,ifwd,useoldcpf)
         do j=1,nlos
            do k=1,nfi
               if((useoldcpf.eq.0).and.(j.eq.ifwd))then
                 if(k.eq.1)then
                   aconst=cpf(i)*omega0
                 else
                   aconst=1.0d0
                 endif
               else if(useoldcpf.eq.1)then
                 aconst=cpf(i)*omega0
               else if(useoldcpf.eq.2)then
                 if(np.eq.1)then
                   aconst=cpf(i)*fmatrx(1,1,k,1,j)*dmu(j)*df*omega0
                 else
                   aconst=cpf(i)*(fmatrx(1,1,k,1,j)+fmatrx(1,2,k,1,j)+
     &fmatrx(2,1,k,1,j)+fmatrx(2,2,k,1,j))*dmu(j)*df*omega0*0.5
                 endif
               endif
               do n=1,np
                  do m=1,np
                     fmatrx(m,n,k,i,j)=fmatrx(m,n,k,i,j)*aconst
                  enddo
               enddo
            enddo
         enddo
      enddo
      return
      end
c ---------------------------------------------------------------------
