c $Header: /usr/people/flittner/radtran/flatpsv/src/czdave.f,v 1.14 1999/08/16 18:57:13 flittner Exp flittner $
c**********************************************************************
      subroutine czdave(intpres,z1,z2,zmod,nz,ndl,k,ierr)
c
c divide the atmosphere using the dave pressure scheme from the altitudes
c z1 to z2 and store the altitudes in the array zmod starting with
c the index k+1 and ending at index k.
c
      implicit none
      include 'consts.cmn'
      include 'param.inc'
      include 'cstdatm.cmn'
c passed
      integer nz,ierr,ndl,k
      real*8 intpres(N),zmod(maxnz),z1,z2
c local
      integer k1,mode,nlayers,i
      real*8 root,pressure,oneatm,y2b(N),yp1,ypn
      logical debug
c external
      real*8 davedps
      external davedps
c
c last mod. Oct. 22, 1998...def
c purpose: re-do finding the first point below z1.
c
c**********************************************************************
      debug=.FALSE.
      oneatm=intpres(1)
      yp1=1.0d30
      ypn=1.0d30
      mode=1
      call spline(intpres,zstd,nstd,yp1,ypn,y2b,mode)
c first find the dave pressure level that is just below the point z1
      k1=1
      pressure=oneatm*davedps(maxdavepslay,ndl,k1)
      if(min(intpres(nstd),intpres(1)).lt.pressure)then
        call splint(intpres,zstd,y2b,nstd,pressure,root,mode)
        if(debug)write(6,*)'czdave. spline z1 root ',z1,root
      else
c assume constant scale height above the std profile
        root=zstd(nstd)+Hp*log(intpres(nstd)/pressure)
        if(debug)write(6,*)'czdave. scale h z1 root ',z1,root,Hp,
     &zstd(nstd),intpres(nstd),pressure
      endif
c find the point just below z1
      do while((z1-root).lt.smallest)
         k1=k1+1
         pressure=oneatm*davedps(maxdavepslay,ndl,k1)
         if(intpres(nstd).lt.pressure)then
           call splint(intpres,zstd,y2b,nstd,pressure,root,mode)
         else
           root=zstd(nstd)+Hp*log(intpres(nstd)/pressure)
         endif
         if(debug)write(6,*)'czdave. pressure z1 root ',
     &pressure,z1,root,k1
      enddo
      if(debug)write(6,*)'czdave. z2 root ',z2,root
c compute grid points until just above z2
      do while((root-z2).gt.smallest)
c solve for height where tau equals tauray
         if(debug)write(6,*)'czdave. from spline pres',pressure,
     &' root',root
         k=k+1
         if(k.gt.maxnz-1)then
           write(6,*)'czdave. nz is greater that maxnz',maxnz
           write(6,*)'czdave. you must recompile with ',
     &'maxnz greater than or equal to',k+1,'.'
           write(6,*)'czdave. root-z2 smallest',root-z2,smallest
           ierr=4
           goto 9999
         end if
         zmod(k)=root
         k1=k1+1
         pressure=oneatm*davedps(maxdavepslay,ndl,k1)
         call splint(intpres,zstd,y2b,nstd,pressure,root,mode)
      enddo
      nlayers=k+1
9999  return
      end
