c $Header: /misc/krotkov/ASH/EP_HEKLA/src/flatpsv.f,v 1.1 2000/01/11 14:58:46 loughman Exp $

      subroutine flatpsv(nz,nlos,ttf,ttr,tto3,tth2o,wavel,
     &thd,z,pres,tf,tray,tabs,aphasefile,ttc,tc,cphasefile,
     &npass,isfc,np,ipseudo,refl,gamma,sun,Fo,
     &lprttop,vthetas,vphis,nvthtop,nvphitop,I0,T,Sbar,Tbar,
     &lprtbot,nvthbot,nvphibot,mvth,mvphi,
     &doforward,lprtflx,linterpms,luseigeo,
     &laureole,thetapmin,thetapmax,dthetap,basename,ierr,
     &thdbnd,phibnd)
C---------------------------------------------------------------------
C Small model
C Extra angle routine added 4/18/94 def
C Aureole output added 8/24/94 def
C T array is changed to 1801 elements (every 0.1 deg) 9/1/94 def
C Pseudo-spherical attenuation of the direct solar beam 10/3/95/ def
C Combine with atmstr program to have all in one code
C Add clouds 10/18/95 def
C Add sfcrho routine 12/18/95 def
C Add aureole program 3/96 def
C last modified: April 15, 1997...def
C purpose: Add rough ocean reflecting surface option
C
C last modified: May 5, 1997...def
C purpose: Move use of refl to crsf only & delete Ig.
C
C last modified: May 7, 1997...def
C purpose: Pass the theta and phi boundaries.
C
C last modified: May 28, 1997...def
C purpose: Pass basename instead of makeing inside flatpsv.  Don't need
C          lwaveloop anymore.
c
c last modified: Dec. 30, 1997...def
c purpose: Increase second dimension of Tfine from 4 to 7 so that can
c          use phase functions created by tmatrix program and liou.
c
C
C---------------------------------------------------------------------
C This program calculates multiple scattering intensities at all
C levels on the zenith for a set of input thetas, typically =5,15,25,...175
C
c The solution of the RTE is as follows; first the solution is found for
c incident sunlight and zero surface albedo; then there is input from the 
c surface an isotropic intensity, Fu, and another solution is found.  The
c two solutions can be combined for any value of surface reflectance using
c I = Io + T*rho/(1-Sbar*rho)
c where T=Fdo/Fu*esi0r and Sbar=Fd/Fu.
c Fu is the upward flux at the surface, Fd is the downward flux at the surface
c for an input of Fu (Fd/Fu is the reflectance of the atmosphere looking from 
c the surface upward, Fdo is the downward flux at the surface of the case 
c of zero surface reflectance.
c
c NOTE: To change number of levels, change nz=number of levels in all
C       the parameter statements in this program and all other programs
C VARIABLES IN THE PROGRAM
C      tabs(i),tf(i),tray(i)= delta tau (for absorption (o3+h2o), aerosol,
C                             rayleigh)
C      fmatrx(m,n,i,j,k)= the phase matrix for aerosol. for incident angle 
C                     theta(i) and phi0 and scattered angle theta(j) and 
C                     azimuth phi=phi0+dphi
C      omega0= single scattering albedo for the aerosol
C      cpf(i)=normalization constant for aerosol phase function at input theta_i
C      cpr(i)=normalization constant for rayleigh phase function 
C      dt(i)=total delta tau of each layer
C      df=delta phi in radians
C      cossun=cosine of solar zenith angle
C      th(i)=scattering angles in radians
C      thd(i)=theta(i) in degrres arranged in ascending order
C      esi0(m,i,l,j)=intensity at level z(l) on the zenith for theta(i)
C                  and phi(j)=df*(j-1), and polarization element m.  Includes
C            surface reflection term.
C      esing0(m,i,l,j) = single scattering intensities. the single scattering 
C                      values  do not include reflectivity contribution
C      pal(i,l)=optical depth along l.o.s starting at level z(l) on the
C               zenith at an angle theta(i). 
C               a) if theta(i) is less than 90 then the the optical depth is 
C                  between level z(l) and z(l-1) i.e for layer l-1 (the 
C                  layer above z(l))
C               b)if theta(i) is greater than 90 then the optical depth is 
C                 between level z(l+1) and z(l) i.e. for layer l (the layer 
C                 below z(l))
C      npass = maximum number of iteration to be performed
C      sun = theta0 (in degrees) of the sun (measured from the zenith)
C      refl = the reflectivity of the surface
C      nlos = no. of observation angles (i.e. no of theta's) ,should be nang
C      mlos = max num of nlos possible
C      nz = no. of levels in the atmosphere (including the surface (level nz)
C      nfi = no. of phi's should be 7 (delta phi is 30 and therefore 7 phi's
C            give phi=0,30,60,...,180
C      sflx0(i) = the solar flux (f0) crossing through level i on the zenith
C      dflux(i) = downward flux crossing level i. on the zenith
C      uflux(i) = upward flux crossing level i. on the zenith
C      sflux(1,2,3,4) =  input solar flux vector at the top of the atmo.
C                  for natrual light sflux(1)=sflux(2) and 3 & 4 are zero.
C      NP = number of polarization parameters to be computed (1,2,3, or 4).
C      ipseudo=switch for attenuation of solar beam (ipseudo=0,flat;
C              ipseudo=1,pseudo spherical).
C
      implicit none
      include 'param.inc'
      include 'consts.cmn'
      include 'catmdata.cmn'
c integer passed
        integer nz,nlos,npass,isfc,np,ipseudo,ierr
        integer nvthtop,nvthbot,nvphitop,nvphibot,mvth,mvphi
c logical passed
        logical lprttop,lprtbot,doforward,lprtflx,linterpms,luseigeo
c real passed
        real*8 ttf,ttr,tto3,tth2o,wavel,ttc,Fo,sun,z(maxnz),gamma,refl
        real*8 tf(maxnlayr),tabs(maxnlayr),tray(maxnlayr),tc(maxnlayr)
        real*8 thd(mlos),pres(maxnlayr),thdbnd(mlos+1),phibnd(nfi+1)
        real*8 vthetas(mvth,2),vphis(mvphi,2)
        real*8 I0(4,mvth,mvphi,2),T(4,mvth,2),Sbar,Tbar
c character passed
        character cphasefile*100,aphasefile*100
c
c local that are passed
c
c variables that are passed
      integer ndownlos,idflag,itlmax
      real*8 cossun,enginp,sflux(4),omega0,pasi0,upflux,dnflux
      real*8 pnigne,upfluxboa,sfcalb

      real*8 esi0(4,nfi,mlos,maxnz),esing0(4,nfi,mlos,maxnz)
      real*8 deltmu(mlos),dmu(mlos),Tfine(nan,7),th(mlos)
      real*8 costh(mlos),sinth(mlos),PfoFmatrx(4,nfi,mlos),pa(maxnz)
      real*8 ProFmatrx(4,nfi,mlos),pal(mlos,maxnz),trans(mlos,maxnz)
      real*8 dt(maxnlayr),cpr(mlos),cpf(mlos)
      real*8 fmatrx(4,4,nfi,mlos,mlos),cpr0,cpf0,phi(nfi)
      real*8 wa(maxnlayr),wr(maxnlayr),cosn(nfi),sinn(nfi)
      real*8 rmatrx(4,4,nfi,mlos,mlos),convrg,geoconvrg
c
      character fname*17,basename*13
      logical aniso,avgall,laureole,ldown
c variables that are local
      logical lefd,lefu
      integer i,n,iend,itest,j,k,L,m
      real*8  ratio,energy,solrflux,sum,Tp,phi0
c extra angle variables
      logical dodirect,exang
      integer ivlev,nvth,nvphi
      real*8 vtheta,vphi,QS,vout(4,maxnz),vsing0(4,maxnz),FT,QSc,FTss
      real*8 voutp(4),vthprt,Itot
c for cloud
      real*8 omega0c,Tfinec(nan,7),PcoFmatrx(4,nfi,mlos),cpc0,
     &cmatrx(4,4,nfi,mlos,mlos),wc(maxnlayr),cpc(mlos)
c for reflecting surface
      integer idirect
      real*8 rsfc0(4,4,nfi,mlos),rsfc(4,4,nfi,mlos,mlos),tmp
      include 'cocean.cmn'
c for isotropic from the bottom
      real*8 esi0r(4,mlos,maxnz),Fdo,Fu,Fd,fluxfactor,Futop
      real*8 esingr(4,mlos,maxnz)
      save esi0r,Fdo,Fu,Fd,fluxfactor,Futop,esingr
      logical readmu
c geometric series
      integer iunt,igeoindx(3),mingeoit
      logical finishi,finishf
      real*8 fluxes(3,2)
c for actinic flux
      real*8 actinic,sflx0(maxnz),actinic2,dnflux2,upflux2,act0(maxnz)
      real*8 actdwn,actup,actdwn2,actup2,ggp,sbp
c external functions
      real*8 flux,actflux,fluxr,actfluxr
      integer igsunt
      external flux,actflux,fluxr,actfluxr,igsunt
c aureole
      real*8 thetapmin,thetapmax,dthetap
c ---------------------------------------------------------------------
      data avgall/.TRUE./
c      data convrg,geoconvrg/0.05d0,1.0d0/
      data convrg,geoconvrg/0.1d0,1.0d0/
      data aniso/.TRUE./
      data readmu/.FALSE./
c set upward flux equal to 0.2
      data Fu/0.2d0/
c set maximum # of iterations in a layer
c itlmax was 10 for regular cloud stuff
      data itlmax/10/
c set the minimum # of iterations for the geometric series
      data mingeoit/6/
c don't print the estimated fluxes to a file
      data lefd,lefu/.FALSE.,.FALSE./
c
C*************************************************************************
C Files needed by the program
C     UNIT 61 - Output file that contains the calculated intensities.
C
c set switches for geometric series
      finishi=.FALSE.
      finishf=.FALSE.
      igeoindx(1)=71
      igeoindx(2)=72
      igeoindx(3)=73
c modified to input mu0 so can compare with Coulson tables
      if(readmu)call creadmu(sun,lprttop,nvthtop,nvphi,vthetas,mvth)
      fname=basename//'.out'
      open(unit=61,file=fname,status='unknown') 
      if(lefd)then
        fname=basename//'.efd'
        open(unit=42,file=fname,status='unknown') 
      endif
      if(lefu)then
        fname=basename//'.efu'
        open(unit=43,file=fname,status='unknown') 
      endif
c
      if(np.eq.1)then
        sflux(1)=Fo
        sflux(2)=0.0d0
        sflux(3)=0.0d0
        sflux(4)=0.0d0
      else
        sflux(1)=Fo*0.5d0
        sflux(2)=Fo*0.5d0
        sflux(3)=0.0d0
        sflux(4)=0.0d0
      endif

      call prtinfo()
C READ INPUT FROM ATMOSPHERIC STRUCTURE PROGRAM
      call readin(PfoFmatrx,ProFmatrx,z,pres,thd,th,sun,dt,
     &ndownlos,
     &costh,sinth,sflux,tf,tabs,tray,omega0,wavel,cpr0,
     &cpr,cpf0,cpf,fmatrx,rmatrx,nz,nlos,
     &npass,cosn,sinn,deltmu,dmu,
     &aniso,gamma,avgall,np,Tfine,
     &QS,wa,wr,
     &ttf,ttr,tto3,tth2o,aphasefile,ipseudo,
     &ttc,tc,cphasefile,omega0c,Tfinec,cmatrx,cpc0,PcoFmatrx,wc,cpc,QSc,
     &phi,isfc)
c
      cossun=dcos(sun*dr)
      enginp=Fo*cossun
      if(enginp.ne.0.0d0)then
        pnigne=1.0d0/enginp
      else
        pnigne=0.0d0
      endif

c calculate the surface reflectance matrix for direct solar beam 
      write(61,*)
      write(61,*) ' REFLECTING SURFACE PARAMETERS'
      write(61,*)
      if(isfc.le.0)then
        write(6,1020)
        write(61,1020)
      else if(isfc.gt.0)then
c isfc = 1 is lambertain surface
c isfc = 2 is ice model
        if(isfc.eq.1)then
          write(61,'(a29)')' LAMBERT REFLECTING SURFACE '
          write(61,'(a31,f6.3)')' SURFACE HEMISPHERIC ALBEDO = ',
     &refl
        else if(isfc.eq.2)then
          write(61,'(a18)')' AVHRR ICE MODEL '
          write(61,'(a31,f6.3)')' SURFACE HEMISPHERIC ALBEDO = ',
     &refl
        else if(isfc.eq.3)then
          write(61,'(a20)')' ROUGH OCEAN MODEL '
          write(61,'(a23,f6.2,a6)')' SURFACE WIND SPEED = ',
     &vocean,' (m/s)'
          write(61,'(a29,f5.3,a3,f5.3)')
     &' OCEAN INDEX OF REFRACTION = ',refrocn,' +i',refiocn
        else if(isfc.eq.4)then
          write(61,'(a20)')' MIRROR MODEL '
          write(61,'(a30,f5.3,a3,f5.3)')
     &' MIRROR INDEX OF REFRACTION = ',refrocn,' +i',refiocn
        endif
        write(61,2100)
        write(61,*)
        phi0=0.0d0
        i=0
        idirect=1
        call crsfc(nlos,mlos,nfi,ndownlos,np,isfc,thd,dmu,deltmu,
     &phi,sun,i,phi0,refl,thdbnd,phibnd,rsfc0,idirect,ierr)
        if(ierr.ne.0)goto 900
      endif
C Preform Gauss-Seidel iteration scheme. The single 
C scattering at all levels and lines of sight is computed on the
C first pass of the iteration scheme. On subsequent passes, subroutines
C downit and upit are used to compute the upward and downward intensities
C from multiple scattering.
  
      write(61,1030)' INPUT SOLAR FLUX AT TOP OF ATMOSPHERE '
c Single scattering iteration
      iend=0
      write(*,9000)iend,npass
      write(*,*) 'flatpsv. COMPUTE SINGLE SCATTER INTENSITIES'
      call cmpsng(ndownlos,nlos,np,nz,ipseudo,costh,cossun,dt,
     &PfoFmatrx,ProFmatrx,sflux,esi0,esing0,pa,pal,pasi0,trans,
     &wa,wr,z,wc,PcoFmatrx,rsfc0,isfc,deltmu)
      idflag=0
      dnflux=flux(nz,ndownlos,esi0,deltmu,nz,nlos,np,idflag)
      idflag=1
      L=1
      upflux=flux(L,ndownlos,esi0,deltmu,nz,nlos,np,idflag)
c calc the solar flux at each level
      do L=1,nz
         sflx0(L)=Fo*cossun*exp(-pa(L))
         act0(L)=Fo*exp(-pa(L))
      enddo
      solrflux=Fo*cossun*exp(-pasi0)
      if(isfc.gt.0)then
        idflag=1
        upfluxboa=flux(nz,ndownlos,esi0,deltmu,nz,nlos,np,idflag)
        energy=(dnflux+solrflux+upfluxboa)-(upflux)
        if(upfluxboa.lt.0.0d0)then
          sfcalb=-upfluxboa/(solrflux)
        else
          sfcalb=0.0d0
        endif
      else
        energy=(dnflux+solrflux)-(upflux)
        sfcalb=0.0d0
      endif
      ratio=energy*pnigne
      write(61,1000)iend
      write(61,1010)enginp,energy,ratio
      write(61,2000)dnflux,upflux,solrflux
      write(61,2050)upfluxboa,sfcalb
      write(6,1010)enginp,energy,ratio
      write(6,2000)dnflux,upflux,solrflux
      write(6,2050)upfluxboa,sfcalb

      if(npass.gt.0)then
        if(isfc.gt.0)then
c calculate the surface reflectance matrix for the diffuse light field
c isfc = 1 is lambertain surface
          phi0=0.0d0
          idirect=0
          do k=1,ndownlos
             call crsfc(nlos,mlos,nfi,ndownlos,np,isfc,thd,dmu,deltmu,
     &phi,thd(k),k,phi0,refl,thdbnd,phibnd,rsfc(1,1,1,1,k),idirect,ierr)
             if(ierr.ne.0)goto 900
          enddo
c swap columns in rsfc since have loaded array as
c rsfc(m,n,phi,theta_out,theta_in), but the array is use like
c rsfc(m,n,phi,theta_in,theta_out).
          do i=ndownlos+1,nlos
             do k=1,ndownlos
                do j=1,nfi
                   do n=1,np
                      do m=1,np
                         tmp=rsfc(m,n,j,i,k)
                         rsfc(m,n,j,i,k)=rsfc(m,n,j,k,i)
                         rsfc(m,n,j,k,i)=tmp
                      enddo
                   enddo
                enddo
             enddo
          enddo
        endif
      endif
      do 60 iend=1,npass
         write(*,9000)iend,npass
         itest=0

         write(*,*)'flatpsv. COMPUTE DOWNWARD INTENSITIES' 
         ldown=.TRUE.
         call downit(itest,ndownlos,esi0,esing0,pal,dmu,wa,wr,
     &fmatrx,rmatrx,trans,nz,nlos,np,convrg,wc,cmatrx,itlmax)
         idflag=0
         dnflux=flux(nz,ndownlos,esi0,deltmu,nz,nlos,np,idflag)

         write(*,*)'flatpsv. COMPUTE UPWARD INTENSITIES' 
         ldown=.FALSE.
         call upit(itest,ndownlos,esi0,esing0,pal,dmu,wa,wr,
     &fmatrx,rmatrx,trans,dnflux,solrflux,nz,
     &nlos,np,convrg,rsfc,wc,cmatrx,isfc,itlmax)
         idflag=1
         L=1
         upflux=flux(L,ndownlos,esi0,deltmu,nz,nlos,np,idflag)
         if(isfc.gt.0)then
           idflag=1
           upfluxboa=flux(nz,ndownlos,esi0,deltmu,nz,nlos,np,idflag)
           energy=(dnflux+solrflux+upfluxboa)-(upflux)
           if(upfluxboa.lt.0.0d0)then
             sfcalb=-upfluxboa/(dnflux+solrflux)
           else
             sfcalb=0.0d0
           endif
         else
           energy=(dnflux+solrflux)-(upflux)
           sfcalb=0.0d0
         endif
         ratio=energy*pnigne
         write(61,1000)iend
         write(61,1010)enginp,energy,ratio
         write(61,2000)dnflux,upflux,solrflux
         write(61,2050)upfluxboa,sfcalb
         write(6,1010)enginp,energy,ratio
         write(6,2000)dnflux,upflux,solrflux
         write(6,2050)upfluxboa,sfcalb
         if(iend.eq.1)then
           fluxes(1,1)=dnflux
           fluxes(1,2)=upflux
         else if(iend.eq.2)then
           fluxes(2,1)=dnflux
           fluxes(2,2)=upflux
         else if(iend.eq.3)then
           fluxes(3,1)=dnflux
           fluxes(3,2)=upflux
         else
           fluxes(1,1)=fluxes(2,1)
           fluxes(1,2)=fluxes(2,2)
           fluxes(2,1)=fluxes(3,1)
           fluxes(2,2)=fluxes(3,2)
           fluxes(3,1)=dnflux
           fluxes(3,2)=upflux
         endif

         if(itest.eq.0) then
            write(6,'(a42,1pe7.1,a48)') 
     &'flatpsv. INTENSITIES CHANGED BY LESS THAN ',convrg,
     &'% --  SOLUTION CONVERGED ENDING ITERATION SCHEME'
            go to 70
         end if
         if(luseigeo.and.(iend.gt.(mingeoit-3)))then
c save iteration values to temperay file
           iunt=70+igsunt(iend)
           open(iunt,status='scratch')
	   call wrtesi0(esi0,nlos,nz,nfi,np,iunt)
           call rotindx(igeoindx)
         else if(luseigeo)then
           call rotindx(igeoindx)
         endif
         if(iend.ge.mingeoit)then
           call chkfgeo(geoconvrg,finishf,fluxes,lefd,lefu)
c check the intensity geometric series to see if can quit now.
	   if(finishf.and.luseigeo)then
             call chkigeo(mlos,maxnz,nfi,nlos,
     &nz,np,igeoindx,geoconvrg,finishi,esi0)
           else
             if(luseigeo)then
               close(igeoindx(1))
             endif
           endif
         endif
         if(finishi)then
           write(6,*)'flatpsv. Will use geometric series to finish ',
     &'the iterations'
           idflag=0
           dnflux=flux(nz,ndownlos,esi0,deltmu,nz,nlos,np,idflag)
           idflag=1
           L=1
           upflux=flux(L,ndownlos,esi0,deltmu,nz,nlos,np,idflag)
           if(isfc.gt.0)then
             idflag=1
             upfluxboa=flux(nz,ndownlos,esi0,deltmu,nz,nlos,np,idflag)
             energy=(dnflux+solrflux+upfluxboa)-(upflux)
             if(upfluxboa.lt.0.0d0)then
               sfcalb=-upfluxboa/(dnflux+solrflux)
             else
               sfcalb=0.0d0
             endif
           else
             energy=(dnflux+solrflux)-(upflux)
             sfcalb=0.0d0
           endif
           ratio=energy*pnigne
           write(61,1000)iend+1
           write(61,1010)enginp,energy,ratio
           write(61,2000)dnflux,upflux,solrflux
           write(6,1010)enginp,energy,ratio
           write(6,2050)upfluxboa,sfcalb
           goto 70
         endif
60    continue

70    call prt(ndownlos,esi0,esing0,z(1),z(nz),thd,nz,nlos,np,
     &isfc)
      if(luseigeo)then
        close(igeoindx(1))
        close(igeoindx(2))
        close(igeoindx(3))
      endif
c
      Fdo=(dnflux+solrflux)
      if(isfc.le.0)then
c now for contribution due to surface
        write(61,3000)
        if(isfc.eq.0)then
          write(6,3000)
          call sfcrho(
     &npass,ndownlos,nz,nlos,np,Fu,esi0r,esingr,
     &deltmu,dmu,costh,sinth,wa,wr,wc,pal,trans,dt,convrg,Fd,Futop,
     &fmatrx,rmatrx,cmatrx,gamma,aniso,itlmax,
     &mingeoit,luseigeo,geoconvrg,lefd,lefu)
          Sbar=Fd/Fu
          Tbar=Futop/Fu
        endif
        fluxfactor=Fdo/Fu
        if(npass.eq.0)fluxfactor=solrflux/Fu
c print these results
        write(61,3010)Fu,fluxfactor
        do i=1,ndownlos
           write(61,3100)thd(i),(esi0r(m,i,nz)*fluxfactor,m=1,4),Sbar,
     &Tbar
        enddo
        do i=ndownlos+1,nlos
           write(61,3100)thd(i),(esi0r(m,i,1)*fluxfactor,m=1,4),Sbar,
     &Tbar
        enddo
        write(61,2100)
        write(61,4013)
c write the ggp and sbp values for the actinic flux at the surface
        idflag=0
        sbp=actfluxr(nz,esi0r,dmu,nz,nlos,np,ndownlos,idflag)/Fu
        idflag=0
        ggp=actflux(nz,esi0,dmu,nz,nlos,np,ndownlos,idflag)
c
        write(61,4015)0.0,enginp,solrflux,dnflux,upflux,Tbar,Sbar,
     &ggp,sbp
        write(61,2100)
      else
        Sbar=0.0d0
        Tbar=0.0d0
        Tp=0.0d0
        ggp=0.0d0
        sbp=0.0d0
        write(61,2100)
        write(61,4013)
        if(isfc.eq.1)then
          if(abs(refl-sfcalb).gt.0.001d0)then
            write(61,4016)
4016  format(" Computed Surface Albedo Differs From Input ",
     &"Surface Reflectance")
          endif
        endif
        write(61,4014)sfcalb,enginp,solrflux,dnflux,upflux
        write(61,2100)
      endif
c now for the output to the aureole program
      if(laureole)then
c make the output file name
        fname=basename//'.aur'
        open(unit=64,file=fname,status='unknown')
        call aureolep(ivlev,thetapmin,thetapmax,dthetap,
     &nlos,np,nz,isfc,npass,ndownlos,
     &aniso,linterpms,
     &Tfine,Tfinec,omega0,omega0c,
     &QS,QSc,deltmu,dmu,dt,sun,cosn,sinn,costh,sinth,thd,trans,
     &wavel,fmatrx,rmatrx,cmatrx,gamma,pa,pal,wa,wr,wc,refl,
     &sflux,Fo,pasi0,Fu,fluxfactor,Sbar,esi0,esing0,esi0r,rsfc0,rsfc,
     &thdbnd,phibnd)
        close(64)
      endif
c now for the extra angles
      do k=1,2
         if((k.eq.1).and.(lprttop))then
           ivlev=1
           nvth=nvthtop
           nvphi=nvphitop
           fname=basename//'.top'
           exang=.TRUE.
           write(6,*)'flatpsv. Computing Table for top of atmo'
         else if((k.eq.2).and.(lprtbot))then
           ivlev=nz
           nvth=nvthbot
           nvphi=nvphibot
           fname=basename//'.bot'
           exang=.TRUE.
           write(6,*)'flatpsv. Computing Table for bottom of atmo'
         else
           exang=.FALSE.
         endif
         if(exang)then
           open(unit=62,file=fname,status='unknown')
           if(k.eq.1)then
             write(61,4010)
             write(62,4010)
           else if(k.eq.2)then
             write(61,4020)
             write(62,4020)
           endif
           if(isfc.le.0)then
c234567890123456789012345678901234567890123456789012345678901234567890
             write(61,4015)0.0,enginp,solrflux,dnflux,upflux,Tbar,Sbar,
     &ggp,sbp
             write(62,4015)0.0,enginp,solrflux,dnflux,upflux,Tbar,Sbar,
     &ggp,sbp
             write(61,4030)
             write(62,4030)
           else
             if(isfc.eq.1)then
               if(abs(refl-sfcalb).gt.0.001d0)then
                 write(61,4016)
                 write(62,4016)
               endif
             endif
             write(61,4014)sfcalb,enginp,solrflux,dnflux,upflux
             write(62,4014)sfcalb,enginp,solrflux,dnflux,upflux
             write(61,4031)
             write(62,4031)
           endif
           do j=1,nvphi
              vphi=vphis(j,k)
              do i=1,nvth
                 vtheta=vthetas(i,k)
                 if(readmu)vtheta=acos(vtheta)/dr
                 if(k.eq.1)then
                   vthprt=180.0d0-vtheta
                 else
                   vthprt=vtheta
                 endif
                 dodirect=.TRUE.
c solve for Intensity in direction vtheta,vphi at level ivlev for zero
c surface reflectance case using esi0 solution.
                 call view(ivlev,nlos,np,nz,
     &aniso,avgall,dodirect,
     &cosn,costh,deltmu,dmu,dt,esi0,
     &fmatrx,gamma,omega0,pa,pal,wa,wr,QS,refl,
     &rmatrx,sflux,wc,cmatrx,omega0c,QSc,Tfinec,
     &sinn,sinth,sun,Tfine,thd,trans,vtheta,vphi,wavel,
     &vsing0,vout,isfc,npass,ndownlos,esing0,linterpms,rsfc0,rsfc,
     &thdbnd,phibnd)
                 do m=1,np
                    I0(m,i,j,k)=vout(m,ivlev)
                 enddo
                 if((j.eq.1).and.(isfc.eq.0))then
                   call viewr(ivlev,nlos,np,nz,dmu,esi0r,pal,trans,Fu,
     &vtheta,T(1,i,k),wa,wr,wc,fmatrx,rmatrx,cmatrx,
     &thd,ndownlos,linterpms)
                 endif
C  Output angle table
                 FT=vout(1,ivlev)
                 if(np.gt.1)FT=FT+vout(2,ivlev)
                 FTss=vsing0(1,ivlev)
                 if(np.gt.1)FTss=FTss+vsing0(2,ivlev)
                 if(isfc.gt.0)then
                   Itot=FT
                   write(61,4210)vthprt,vphi,refl,sun,FT,FTss
                   write(62,4210)vthprt,vphi,refl,sun,FT,FTss
                 else
                   Tp=T(1,i,k)
                   if(np.gt.1)Tp=Tp+T(2,i,k)
                   Tp=Tp*fluxfactor
                   Itot=FT+Tp*refl/(1.0d0-Sbar*refl)
                   write(61,4210)vthprt,vphi,refl,sun,FT,Itot,Tp,
     &Sbar,FTss
                   write(62,4210)vthprt,vphi,refl,sun,FT,Itot,Tp,
     &Sbar,FTss
                 endif
              enddo
              write(6,'(a35,f7.1)')' flatpsv. finished with phi angle ',
     &vphi
           enddo
           close(62)
         endif
      enddo
c do the forward direction
      if(doforward)then
        ivlev=nz
        vtheta=sun
        vphi=0.0d0
c solve for Intensity in direction vtheta,vphi at level ivlev for zero
c surface reflectance case using esi0 solution.
        call view(ivlev,nlos,np,nz,
     &    aniso,avgall,doforward,
     &    cosn,costh,deltmu,dmu,dt,esi0,
     &    fmatrx,gamma,omega0,pa,pal,wa,wr,QS,refl,
     &    rmatrx,sflux,wc,cmatrx,omega0c,QSc,Tfinec,
     &    sinn,sinth,sun,Tfine,thd,trans,vtheta,vphi,wavel,
     &    vsing0,vout,isfc,npass,ndownlos,esing0,linterpms,rsfc0,rsfc,
     &thdbnd,phibnd)
          if(isfc.eq.0)call viewr(ivlev,nlos,np,nz,
     &dmu,esi0r,pal,trans,Fu,vtheta,voutp,wa,wr,wc,fmatrx,rmatrx,
     &cmatrx,thd,ndownlos,linterpms)
c now compute the multipling factor to get the intensities
        FT=vout(1,ivlev)
        if(np.gt.1) then
           FT=FT+vout(2,ivlev)
        endif
C  Output angle table
        write(61,*)'Values for the Forward direction at the surface'
        write(61,4100)vtheta,vphi,(vout(m,ivlev),m=1,4),FT,
     &vsing0(1,ivlev),vsing0(2,ivlev)
        if(isfc.eq.0)then
          write(61,3100)vtheta,(voutp(m)*fluxfactor,m=1,4),Sbar,Tbar
        endif
      end if

      write(61,*)
      write(61,*)
      write(61,*)
      write(61,*)
c
      if(lprtflx)then
        fname=basename//'.flx'
        open(unit=63,file=fname,status='unknown')
        do iunt=61,63,2
           write(iunt,1100)
           write(iunt,*)
           write(iunt,*)
           write(iunt,1040)' SURFACE HEMISPHERIC ALBEDO = ',refl
           write(iunt,5000)
        enddo
        if(isfc.le.0)sum=fluxfactor*refl/(1.0d0-sbar*refl)
        do L=1,nz
c calc the up, down & net flux at each level also
           idflag=0
           dnflux=flux(L,ndownlos,esi0,deltmu,nz,nlos,np,idflag)
           actdwn=actflux(L,esi0,dmu,nz,nlos,np,ndownlos,idflag)
           idflag=1
           actup=actflux(L,esi0,dmu,nz,nlos,np,ndownlos,idflag)
           upflux=flux(L,ndownlos,esi0,deltmu,nz,nlos,np,idflag)
           if(isfc.le.0)then
             idflag=0
             actdwn2=actfluxr(L,esi0r,dmu,nz,nlos,np,ndownlos,idflag)
	     dnflux2=fluxr(L,ndownlos,esi0r,deltmu,nz,nlos,np,idflag)
             idflag=1
             actup2=actfluxr(L,esi0r,dmu,nz,nlos,np,ndownlos,idflag)
	     upflux2=fluxr(L,ndownlos,esi0r,deltmu,nz,nlos,np,idflag)
             actup=actup+actup2*sum
             actdwn=actdwn+actdwn2*sum
             dnflux=dnflux+dnflux2*sum
             upflux=upflux+upflux2*sum
           endif
c
           if(L.eq.1)then
             write(61,5110)act0(L),actdwn,actup,dnflux,upflux,
     &dnflux+upflux+sflx0(L)
             write(63,5110)act0(L),actdwn,actup,dnflux,upflux,
     &dnflux+upflux+sflx0(L)
           else
             write(61,5100)z(L),act0(L),actdwn,actup,dnflux,upflux,
     &dnflux+upflux+sflx0(L)
             write(63,5100)z(L),act0(L),actdwn,actup,dnflux,upflux,
     &dnflux+upflux+sflx0(L)
           endif
        enddo
        close(63)
      endif
900   continue
      close(61)
      if(lefd)close(42)
      if(lefu)close(43)
c

1020  format(1x,'*****',/,' ***** Have selected Lambertian reflecting',
     &' surface.',/,' ***** So will present solution in two parts.',/,
     &' ***** First is for solar flux input at top of atmosphere.',/,
     &' ***** Second is for input flux at bottom of atmosphere with ',
     &'isotropic ',/,
     &' ***** upward intensity at bottom of atmosphere.',/,' *****')
1030  format(7x,10('#'),1x,a40,1x,10('#'))
1040  format(7x,10('#'),1x,a31,1x,f5.2,4x,10('#'))
1000  format(1x,'ITERATION NO ',i4)
1010  format(1x,' ENRG INP=',1Pe11.4,
     &' ENRG OUT=',1Pe11.4,' ENRG OUT/ENRG INP=',1Pe11.4)
1100  format(11x,56('*'))
2000  format(5x,'DFLUX=',1Pe11.4,' UPFLUX= ',1Pe11.4,
     &' SOLFLUX=',1Pe11.4) 
2050  format(5x,'UPFLUX @ BOA=',1Pe11.4,' SFC ALBEDO= ',1Pe11.4)
2100  format(/,/,78('*'))
3000  format(78('*'),//,5x,'NOW FOR ISOTROPIC UPWARD FLUX AT SURFACE',/)
3010  format(/,1x,'CALCULATIONS FOR ISOTROPIC UPWARD FLUX OF ',
     &1PE12.4,/,1x,'THE RATIO OF DOWNWARD + DIRECT SOLAR',
     &' FLUX TO UPWARD ISOTROPIC IS',1PE12.4,/,
     &1x,'Theta',6x,'T(1)',8x,'T(2)',8x,'T(3)',8x,'T(4)',7x,'Sbar',
     &8x,'Tbar')
3100  format(f7.2,1P6E12.4)
4000  format(/,/,1x,'CALCULATIONS FOR EXTRA ANGLES',/,/)
4010  format(/,/,1x,'CALCULATIONS FOR TOP OF THE ATMOSPHERE',/,
     &1x,'The theta angle is the angle between the radiation',
     &' propagation',/,' vector and the zenith.',/,/)
4013  format(1x,'SUMMARY OF FINAL FLUX RESULTS:')
4014  format(17x,'(CALCULATED SURFACE ALBEDEO =',f5.2,')'/,
     &3x,'SOLAR FLUX   SOLAR FLUX   DIFFUSE DOWN  DIFFUSE UP',
     &/,5x,'@ TOA',8x,'@ SFC',8x,'@ SFC',8x,'@ TOA',/,1P4E13.4)
c4015  format(17x,'(CALCULATED SURFACE ALBEDEO =',f5.2,')'/,
c     &3x,'SOLAR FLUX   SOLAR FLUX   DIFFUSE DOWN  DIFFUSE UP',5x,'TBAR',
c     &9x,'SBAR',
c     &/,5x,'@ TOA',2(8x,'@ SFC'),2(8x,'@ TOA'),8x,'@ SFC',/,1P6E13.4)
4015  format(17x,'(CALCULATED SURFACE ALBEDEO =',f5.2,')'/,
     &2x,'SOLAR',5x,'SOLAR',3x,'DIFF DOWN',3x,'DIFF UP',5x,'TBAR',
     &6x,'SBAR',4x,'DIFF DOWN',3x,'SBARP',/,
     &'FLUX @TOA FLUX @SFC FLUX @SFC  FLUX @TOA    @ TOA     ',
     &'@ SFC   ACT @SFC    @SFC',/,1PE9.3,1P2E10.3,1P2E11.3,1P3E10.3)
4020  format(/,/,1x,'CALCULATIONS FOR BOTTOM OF THE ATMOSPHERE',/,
     &1x,'The theta angle is the angle between the radiation',
     &' propagation',/,' vector and the nadir.',/,/)
4030  format(' THETA   PHI   RHO  SOLAR  I(RHO=0)    I(RHO)       T ',
     &'       SBAR       Iss0',/,' (DEG)  (DEG)       ZENITH')
4031  format(' THETA   PHI   RHO  SOLAR   I(RHO)     Iss(RHO)',
     &/,' (DEG)  (DEG)       ZENITH')
4100  format(F6.2,F6.1,1P2E11.4,1P2E12.4,1P3E11.4)
4200  format(F6.2,F6.1,F6.2,F7.2,1P4E12.4)
4210  format(F6.2,F6.1,F6.2,F7.2,1P5E11.4)
5000  format(//,19x,'FLUX VARIATION WITH ALTITUDE',///,
     &'  Jdir = Direct Actinic Flux (solar flux through surface ',
     &'perpendicular to',/
     &'         solar beam',/
     &'  Jdd  = Diffuse Downward Actinic Flux',/
     &'  Jdu  = Diffuse Upward Actinic Flux',/
     &'  Fdd  = Diffuse Downward Flux (flux through horizonatal ',
     &'surface)',/
     &'  Fdu  = Diffuse Upward Flux (flux through horizonatal ',
     &'surface)',/
     &'  Ftot = Net Flux through horizontal surface (Fdd+Fdu+Jdir*',
     &'cos(solar_zenith)',/,/,/
     &'Alt (km)  Jdir         Jdd         Jdu         Fdd',
     &'          Fdu         Ftot',/,78('*'))
5100  format(f7.3,1P4E12.5,1PE13.5,1PE12.5)
5110  format('Atm Top' ,1P4E12.5,1PE13.5,1PE12.5)
6000  format(a7,f3.1)
6100  format(a6,f4.1)
9000  format(1x,'--------',16x,'ITERATION ',i4,' OUT OF ',i4,
     &17x,'--------')

      return
      end
c ---------------------------------------------------------------------
