c $Header: /usr/people/flittner/radtran/flatpsv/src/flux.f,v 1.14 1999/08/16 18:57:14 flittner Exp flittner $
c ---------------------------------------------------------------------

      real*8 function flux(lev,ndownlos,esi0,deltmu,nz,nlos,
     &np,iflag)

C CALCULATE FLUX UP OR DOWN ON THE ZENITH THROUGH LEVEL LEV
C ESI0 IS THE INTENSITY DISTRIBUTION AT THIS LEVEL
 
      implicit none
      include 'consts.cmn'
      include 'param.inc'
c variables that are passed
      integer lev,ndownlos,nz,nlos,np,iflag
      real*8 esi0(4,nfi,mlos,maxnz),deltmu(mlos)
c variables that are local
      integer ie,i,is,k
      real*8 sum,const
C First set range for theta integration for flux up or down by checking
C iflag.  If iflag = 0 then downward and if iflag = 1 then upward.
C    LEV=1 ; Then at the top of the atmosphere and is the upward case.
C    LEV=NZ; Then at the surface and is the downward case.
C is denotes the starting point of the summation.
C ie denotes the ending point of the summation.
C The i counter variable in do loop represents theta direction.
C The k counter variable is for phi.
C The constant c is used to incorporate the symmetry used.

      if(iflag.eq.1)then
         is=ndownlos+1
         ie=nlos
      else if(iflag.eq.0)then
         is=1
         ie=ndownlos
      endif
      sum=0.0
      do 1 i=is,ie
         k=1
         const=deltmu(i)*df
         sum=sum+esi0(1,k,i,lev)*const
         if(np.gt.1)then
            sum=sum+esi0(2,k,i,lev)*const
         endif
         const=deltmu(i)*df*2.0d0
         do 2 k=2,nfi-1
            sum=sum+const*esi0(1,k,i,lev)
            if(np.gt.1)then
               sum=sum+const*esi0(2,k,i,lev)
            endif
2        continue
         k=nfi
         const=deltmu(i)*df
         sum=sum+esi0(1,k,i,lev)*const
         if(np.gt.1)then
            sum=sum+esi0(2,k,i,lev)*const
         endif
1     continue
      flux=sum

      return
      end

c ---------------------------------------------------------------------
