c $Header: /usr/people/flittner/radtran/flatpsv/src/intaur.f,v 1.14 1999/08/16 18:59:08 flittner Exp flittner $
*********************************************************************
c subroutine to integrate the Intensity within a solid angle about the
c     sun with a half angle of thetap(j)+dthetap/2, including the 
c     forward peak, resulting in a flux value.
c
      subroutine intaur(Inten,maxnphi,maxnthetap,nphi,
     &     thetap,nthetap,delphi,Ifwd,sunomega,dr,
     &     dthetap,sun,Fo,direct)
c
      implicit none
c passed
      integer nphi,nthetap,maxnphi,maxnthetap
      real*8 dr,Inten(maxnphi,maxnthetap),
     &     thetap(maxnthetap),
     &     delphi,Ifwd,sunomega,dthetap,sun,
     &     direct,Fo
c local
      integer i,j
      real*8 Faur,theta1,theta2,theta3,sum1,sum2,dsum,a(3),dp,dt
c
      dp=delphi*dr
      dt=dthetap*dr
      theta1=0.0d0
      theta2=thetap(1)*dr
      a(1)=Ifwd
      a(2)=0.0d0
      a(3)=Inten(1,1)-a(1)
      a(3)=a(3)/theta2/theta2
      call integ(a,theta1,theta2,sum1)
      do 20 i=2,nphi-1
           a(3)=Inten(i,1)-a(1)
           a(3)=a(3)/theta2/theta2
           call integ(a,theta1,theta2,dsum)
           sum1=sum1+2.0d0*dsum
20    continue
      a(3)=Inten(nphi,1)-a(1)
      a(3)=a(3)/theta2/theta2
      call integ(a,theta1,theta2,dsum)
      sum1=sum1+dsum
      Faur=sum1*dp
      write(61,*)
      write(61,'(a25,1Pe9.3)')'the direct flux value is ',direct*Fo
      write(61,1005)Faur*Fo
      write(64,*)
      write(64,'(a25,1Pe9.3)')'the direct flux value is ',direct*Fo
      write(64,1005)Faur*Fo
c
c now for the other rings.
c
      write(61,*)'the integrated diffuse Flux over the peak:'
      write(61,1010)
      write(61,1020)0.5,Faur*Fo,Faur/direct
      write(64,*)'the integrated diffuse Flux over the peak:'
      write(64,1010)
      write(64,1020)0.5,Faur*Fo,Faur/direct
      do 40 j=1,nthetap-2,2
	   theta1=thetap(j)*dr
	   theta2=thetap(j+1)*dr
	   theta3=thetap(j+2)*dr
           i=1
           call findcoe(Inten(i,j),Inten(i,j+1),Inten(i,j+2),theta1,
     &           dt,a)
           call integ(a,theta1,theta2,sum1)
           call integ(a,theta2,theta3,sum2)
           do 30 i=2,nphi-1
                 call findcoe(Inten(i,j),Inten(i,j+1),Inten(i,j+2),
     &			theta1,dt,a)
                 call integ(a,theta1,theta2,dsum)
                 sum1=sum1+dsum*2.0d0
                 call integ(a,theta2,theta3,dsum)
                 sum2=sum2+dsum*2.0d0
30	   continue
           i=nphi
           call findcoe(Inten(i,j),Inten(i,j+1),Inten(i,j+2),theta1,
     &           dt,a)
           call integ(a,theta1,theta2,dsum)
           sum1=sum1+dsum
           Faur=Faur+sum1*dp
           write(61,1020)2.0d0*theta2/dr,Faur*Fo,Faur/direct*100.0
           write(64,1020)2.0d0*theta2/dr,Faur*Fo,Faur/direct*100.0
           call integ(a,theta2,theta3,dsum)
           sum2=sum2+dsum
           Faur=Faur+sum2*dp
           write(61,1020)2.0d0*theta3/dr,Faur*Fo,Faur/direct*100.0
           write(64,1020)2.0d0*theta3/dr,Faur*Fo,Faur/direct*100.0
40    continue
      if((j-2).lt.(nthetap-2))then
	   j=nthetap-2
           theta1=thetap(nthetap-2)*dr
           theta2=thetap(nthetap-1)*dr
	   theta3=thetap(nthetap)*dr
           i=1
           call findcoe(Inten(i,j),Inten(i,j+1),Inten(i,j+2),theta1,
     &           dt,a)
           call integ(a,theta2,theta3,sum2)
           do 50 i=2,nphi-1
                 call findcoe(Inten(i,j),Inten(i,j+1),Inten(i,j+2),
     &			theta1,dt,a)
                 call integ(a,theta2,theta3,dsum)
                 sum2=sum2+dsum*2.0d0
50	   continue
           i=nphi
           call findcoe(Inten(i,j),Inten(i,j+1),Inten(i,j+2),theta1,
     &           dt,a)
           call integ(a,theta2,theta3,dsum)
           sum2=sum2+dsum
           Faur=Faur+sum2*dp
           write(61,1020)2.0d0*theta3/dr,Faur*Fo,Faur/direct*100.0
           write(64,1020)2.0d0*theta3/dr,Faur*Fo,Faur/direct*100.0
      end if
1005  format(1x,'The integrated diffuse flux in the forward',
     &' direction is ',1Pe9.3,'.')
1010  format(1x,'solid angle with',/,'  vertex angle of',5x,
     &'Integrated',12x,'Diffuse/Direct*100',/,3x,'theta (deg)',
     &8x,'Diffuse Flux')
1020  format(3x,f5.2,2(15x,e10.4))
      return
      end

*********************************************************************
