c $Header: /usr/people/flittner/radtran/flatpsv/src/interpmsr.f,v 1.14 1999/08/16 18:59:07 flittner Exp flittner $
C----------------------------------------------------------------------
        subroutine interpmsr(nlos,nz,np,esi0r,thd,ndownlos,
     &vtheta,ivlev,voutmsr)
c
c
c Interpolate the azimuth independent reflectance term using cubic 
c interpolation in theta.
c
c For the theta interpolation, the dependent varible is assumed to have 
c even-symmetry about 0 and 180.  The this symmetry is accomplished by 
c adding nex values below 0 and nex2 values above 180.
c
	implicit none
        include 'consts.cmn'
        include 'param.inc'
c constants passed from the calling program
	integer nlos,nz,np,ndownlos,ivlev
c values calculated before hand that will be used in calculations
	real*8 esi0r(4,mlos,maxnz),thd(mlos),vtheta
	real*8 voutmsr(4)
c
c local
        integer nex,nex2,mex,mex2,mode
        parameter (mex=2,mex2=2)
        integer i,m,ie,is,ny
        real*8 y(mlos+mex+mex2),yp2(mlos+mex+mex2)
        real*8 yp1,ypn,x(mlos+mex+mex2),xv,x0
        logical lusecosx
c
c will use "natrual" spline
        yp1=1.0d30
        ypn=1.0d30
        mode=0
        lusecosx=.FALSE.
c
c inital ize to zero
c
        do i=1,mlos+mex+mex2
           y(i)=0.0d0
        enddo
        do i=1,mlos+mex+mex2
           x(i)=0.0d0
        enddo
c
c for the level, get the data points
c
        if(vtheta.lt.90.0d0)then
          is=1
          ie=ndownlos
          nex=2
          nex2=0
          ny=ndownlos+nex+nex2
          x0=0.0d0
        else
          is=ndownlos+1
          ie=nlos
          nex=0
          nex2=2
          ny=(nlos-ndownlos)+nex+nex2
          x0=180.0d0
        endif
        xv=vtheta
c
        do i=is,ie
           x(nex+1+i-is)=thd(i)
        enddo
        do i=1,nex
           x(nex+1-i)=x0-x(nex+i)
        enddo
        do i=1,nex2
           x(ny-nex2+i)=360.0d0-x(ny-nex2+1-i)
        enddo
c
c use cosine of angle.  Be carefull for the angles less than 0 and greater
c than 180.
c
        if(lusecosx)then
          do i=1,ny
             if(x(i).lt.0.0.and.x(i).gt.-90.0)then
               x(i)=1.0+(1.0-cos(x(i)*dr))
             else if(x(i).gt.180.0.and.x(i).lt.270.0)then
               x(i)=-1.0-(1.0+cos(x(i)*dr))
             else
               x(i)=cos(x(i)*dr)
             endif
          enddo
          if(xv.lt.0.0.and.xv.gt.-90.0)then
            xv=1.0+(1.0-cos(xv*dr))
          else if(xv.gt.180.0.and.xv.lt.270.0)then
            xv=-1.0+(1.0+cos(xv*dr))
          else
            xv=cos(xv*dr)
          endif
        endif
c
        do m=1,np
           do i=is,ie
              y(nex+1+i-is)=esi0r(m,i,ivlev)
           enddo
           do i=1,nex
              y(nex+1-i)=y(nex+i)
           enddo
           do i=1,nex2
              y(ny-nex2+i)=y(ny-nex2+1-i)
           enddo
           call spline(x,y,ny,yp1,ypn,yp2,mode)
           call splint(x,y,yp2,ny,xv,voutmsr(m),mode)
        enddo
        return
        end
