c $Header: /usr/people/flittner/radtran/flatpsv/src/paero2.f,v 1.14 1999/08/16 18:57:14 flittner Exp flittner $
      subroutine paero2(Tfine,p,captheta,cos_captheta,fsbs,
     &ANUP,AMUP,AMU,ANU,COSN,SINN)
c
c compute the aerosol phase function using the non-spherical 
c phase function.  This is only coded for 1 stokes parameter at this 
c time.  So, the azimuth angle does not matter, just the scattering
c angle.
c
c Tfine(1,*)  = non-spherical scattering phase function as a function
c               of scattering angle in degrees.
c Tfine(1,*)  = scattering angle
c Tfine(2,*)  = F11
c Tfine(3,*)  = F22
c Tfine(4,*)  = F33
c Tfine(5,*)  = F44
c Tfine(6,*)  = F12
c Tfine(7,*)  = F34
c cos_captheta=cosine of scattering angle
c fsbs
c anup = sin of input theta
c amup = -cosine of input theta
c anu = sin of output theta
c amu = -cosine of output theta
c cosn = cosine of relative azimuth
c sinn = sin of the relative azimuth
c
c output
c
c p(4,4)  - aerosol scattering matrix
c
c
c get the index in the Tfine array for the values that straddle the 
c scattering angle.
c
c last modified: Dec. 30, 1997...def
c purpose: Increase second dimension of Tfine from 4 to 7 so that can
c          use phase functions created by tmatrix program and liou.
c
c last modified: Apr. 16, 1998...def
c purpose: Rotate matrix from scattering plane to vertical plane
c
c
      implicit none
      include 'param.inc'
      include 'consts.cmn'
c passed
      real*8 Tfine(nan,7),p(4,4)
      real*8 captheta,cos_captheta
      logical fsbs
      real*8 anup,amup,anu,amu,cosn,sinn
c local
      integer MT,MTP1,j,one,mode,ierror
      logical sort,monoton
      real*8 T1(6)
      real*8 YA,onemya,rnan
c rotational stuff
      integer n,m
      real*8 C,S,CS,SS,cpsis,cpsi,calf0,phiout,phiin
      real*8 r(4,4),d(4,4),ctmp,stmp,cossun,sinsun,costh,sinth
c
      call Tfineindx(cos_captheta,captheta,YA,onemya,MT,MTP1)
c
        if(cos_captheta.ge.1.0d0) then
          cos_captheta=1.0d0
          captheta=0.0d0
          YA=1.0d0
          MT=1
          MTP1=2
          onemya=0.0d0
        else if(cos_captheta.le.-1.0d0) then
          cos_captheta=-1.0d0
          captheta=180.0d0
          YA=0.0d0
          MTP1=nan
          MT=nan-1
          onemya=1.0d0
        else
c we should do the following
c anglefactor should be 1.0 since only have 181 angles
          captheta=dacos(cos_captheta)/dr
          MT=int(captheta)
          onemya=(captheta-dble(MT))
          if(onemya.lt.0.0d0) onemya=-onemya
          ya=1.0d0-onemya
          MT=MT+1
          MTP1=MT+1
          if((MT.lt.1).or.(MT.ge.181))then
             write(6,*)'Tfineindx. cos_captheta=',cos_captheta
             write(6,*)'Tfineindx. captheta=',captheta,' MT=',MT
             stop
          endif
        endif
c
      one=1
      mode=4
      sort=.FALSE.
      monoton=.FALSE.
      rnan=181
      do j=1,6
c	 call smoothb(Tfine(1,1),Tfine(1,j+1),nan,rnan,sort,captheta,
c     &T1(j),one,one,ierror,mode,monoton)
         T1(j)=YA*Tfine(MT,j+1)+onemya*Tfine(MTP1,j+1)
      enddo
c convert from (I,Q,U,V) to (I1,I2,U,V)
***********************************************************************
      p(1,1)=0.5d0*(T1(1)+2.0d0*T1(5)+T1(2))
      p(1,2)=0.5d0*(T1(1)-T1(2))
      p(2,1)=0.5d0*(T1(1)-T1(2))
      p(2,2)=0.5d0*(T1(1)-2.0d0*T1(5)+T1(2))
      p(3,3)=T1(3)
      p(4,4)=T1(4)
      p(3,4)=T1(6)
      p(4,3)=-T1(6)
c zero-out the others
      p(1,3)=0.0d0
      p(1,4)=0.0d0
      p(2,3)=0.0d0
      p(2,4)=0.0d0
      p(3,1)=0.0d0
      p(3,2)=0.0d0
      p(4,1)=0.0d0
      p(4,2)=0.0d0
c***********************************************************************
c now rotate from scattering plane to the vertical plane
c
c common problem with this theta angle definition is having to continually
c switch the sign of the cosine of the angles. Must do so here again
c
      cossun=-amup
      costh=-amu
      sinsun=anup
      sinth=anu
c
c compute the angles for this problem so we can rotate the scattering
c matrix from the scattering plane to the vertical plane
c
      phiout=acos(cosn)
      phiin=0.0d0
      call crotang(costh,phiout,cossun,phiin,c,s,cs,ss,cpsis,cpsi,
     &calf0)
c 
c compute the reflection matrix transformed to the vertical plane
c first rotate angle -psip in clockwise direction and then (pi-psi) in CW
c
      ss=-ss
      s=-s
c      call scat2vert(r1,r2,C,S,Cs,Ss,p)
      n=4
c
c make the first rotation matrix for angle pi-psi in the CW direction.
c However, we have cosine(2psi)=c and sine(2psi)=s.
c Remember, cosine(pi-psi)=-cosine(psi) and sine(pi-psi)=sine(psi),
c and cosine(2*(pi-psi))=cos(2*psi) & sine(2*(pi-psi))=-sine(2*psi).
c So, change the sign of sine(2*psi).
c
      ctmp=c
      stmp=-s
      call mkrot(ctmp,stmp,r)
c
c multiply first rotation times the scattering matrix
c
      call matmul(r,n,n,p,n,d)
c
c the second rotation matrix for angle -psip in the CW direction
c However, we have cosine(2psip)=cs and sine(2psip)=ss.
c Remember, cosine(-2psip)=cosine(2psip), sine(-2psip)=-sine(2psip).
c So have adjusted stmp with minus sign.
c
      ctmp=cs
      stmp=-ss
      call mkrot(ctmp,stmp,r)
c
c multiply second rotation times the scattering matrix
c
      call matmul(d,n,n,r,n,p)
      return
      end
c***********************************************************************
