c $Header: /usr/people/flittner/radtran/flatpsv/src/pray0.f,v 1.14 1999/08/16 18:57:14 flittner Exp flittner $
******************************************************************
      subroutine pray0(costh0,sinth0,costh,sinth,gamma,rmat,np,aniso)

C
c rmat(m,n) is the azimuth independent rayleigth scattering matrix for input 
c angle costh0,output angle costh.
c
c note that minus signs are used in cos of theta angles because
c phase matrix is computed using a theta angle of 0.0 for a 
c beam traveling straight up and L.O.S. are read-in in the 
c subroutine read ( which means that the beam traveling straight
c up is discribed by the los angle 180.0.
C      AMU = -cos(output angle)
C      ANU = sin(output angle)
C      AMUP = -cos(incident angle)
C      ANUP =  sin(incident angle)
C      AMUSQ = cos()cos()
C      AMUMU = -cos()cos(solar zenith angle)
C      AMUPS = cos(solar zenith angle) squared
C
c
      implicit none
      include 'consts.cmn'
c passed to Rayphase
      integer np
      real*8 costh,sinth,rmat(4,4),costh0,sinth0,gamma
      logical aniso
c aniso is switch for using anisotropic Rayleigh particales with
c anisotropy factor of gamma
c local
      real*8 ANUP,AMUP,ANUPS,ANUSQ,AMUMU,AMUSQ,AMUPS,AMU,ANU
      real*8 const,f
c
      AMUP=costh0
      ANUP=sinth0
      AMUPS=AMUP*AMUP
      ANUPS=ANUP*ANUP
      if(aniso)then
        f=3.0d0/4.0d0*gamma/(1.0d0+2.0d0*gamma)
        const=3.0d0/8.0d0/pi*(1.0d0-gamma)/(1.0d0+2.0d0*gamma)
      else
        f=0.0d0
        const=3.0d0/8.0d0/pi
      endif
c output theta angle
      AMU=-costh
      ANU=sinth
      AMUSQ=AMU*AMU
      ANUSQ=ANU*ANU
      AMUMU=AMU*AMUP
c scattering matrix
      rmat(1,1)=pi*(2.0d0*ANUSQ*ANUPS+AMUPS*AMUSQ)*const
      rmat(1,2)=(AMUSQ*pi)*const
      rmat(1,3)=0.0D0
      rmat(1,4)=0.0D0
      rmat(2,1)=(AMUPS*pi)*const
      rmat(2,2)=(pi)*const
      rmat(2,3)=0.0D0
      rmat(2,4)=0.0D0
      rmat(3,1)=0.0D0
      rmat(3,2)=0.0D0
      rmat(3,3)=0.0D0
      rmat(3,4)=0.0D0
      rmat(4,1)=0.0D0
      rmat(4,2)=0.0D0
      rmat(4,3)=0.0D0
      rmat(4,4)=(pi*2.0d0*AMUMU)*const
c add isotropic portion for anisotropy
      if(aniso)then
        rmat(1,1)=rmat(1,1)+f
        rmat(1,2)=rmat(1,2)+f
        rmat(2,1)=rmat(2,1)+f
        rmat(2,2)=rmat(2,2)+f
      endif
c 
      if(np.eq.1)then
        rmat(1,1)=0.5d0*(rmat(1,1)+rmat(1,2)+rmat(2,1)+rmat(2,2))
        rmat(1,2)=0.0d0
        rmat(2,1)=0.0d0
        rmat(2,2)=0.0d0
        rmat(4,4)=0.0d0
      else if(np.lt.4)then
        rmat(4,4)=0.0d0
      endif
      RETURN
      END
***********************************************************************
