c $Header: /usr/people/flittner/radtran/flatpsv/src/read51.f,v 1.14 1999/08/16 18:59:08 flittner Exp flittner $
C########################################################################

	subroutine read51(ttf,ttr,totoz,totwat,wavel,ttc,sfcprs,Fk,
     &o3coe,top,dtaumax,h2ocoe,aerodist,clddist,pcldtop,pcldbot,
     &daveps,ndl,
     &iangtyp,
     &npass,isfc,np,ipseudo,nsun,
     &refl,suns,Fo,vthmintop,vthmaxtop,dvthtop,vphimintop,
     &vphimaxtop,dvphitop,vthminbot,vthmaxbot,dvthbot,vphiminbot,
     &vphimaxbot,dvphibot,lprttop,lprtbot,doforward,lprtflx,
     &iatmtype,lgcorrect,linterpms,luseigeo,lchkdz,aerz0,aersig,
     &laureole,thetapmin,thetapmax,dthetap,deltaoz,ierr,lthkcld,
     &lwaveloop)
C
C read the input file 51
C
C last modified: April 15, 1997...def
C purpose: add rough ocean reflecting surface option
C
C last modified: April 17, 1997...def
C purpose: add mirror reflecting surface option
C
C last modified: May 28, 1997...def
C purpose: read lwaveloop from the addswitchs file
C
C last modified: July 21, 1997...def
C purpose: use maxiflag to set upper limit on the size dist. flag
C
C last modified: May 13, 1998...def
C purpose: add option for Power law with anu=2 and input the effective
C radius and variance and will calc. the min and max radii.
C
C last modified: Oct. 28, 1998...def
C purpose: input the # of sigmas for the rmin,rmax calculation for
C iflag=10.
C
C last mod. Dec. 30, 1998...def
C purpose: for iflag=1, input the maximum radius of constant dn/dlogr
C
C-----------------------------------------------------------------
c

	implicit none
c atmstr variables that are passed back
        integer iatmtype,ndl,ierr
        logical lgcorrect,daveps,lchkdz,lthkcld
        real*8 ttc,ttf,ttr,totoz,totwat,wavel,sfcprs
        real*8 Fk,refl
	real*8 o3coe(3),top,dtaumax,h2ocoe
        real*8 aerodist(22),clddist(22),pcldtop,pcldbot,aerz0,aersig
        real*8 deltaoz
c set theta stuff
        integer iangtyp
c flat code stuff
        integer npass,isfc,np,ipseudo,nsun
        real*8 suns(12),Fo,vthmintop,vthmaxtop,dvthtop,vphimintop
        real*8 vphimaxtop,dvphitop
        real*8 vthminbot,vthmaxbot,dvthbot,vphiminbot,vphimaxbot
        real*8 dvphibot
        logical lprttop,lprtbot,doforward,lprtflx,linterpms,luseigeo
        logical lwaveloop
c aureole stuff
        logical laureole    
        real*8 thetapmin,thetapmax,dthetap
c commons
        logical levendx
        common /othrswch/levendx
        save /othrswch/
        include 'cocean.cmn'
c local
        character fname*100
        integer i,maxiflag
        logical debug,ex
        real*8 thkcldmin
c namelist
        logical useigeo,interpms,chkdz,aureole,thkcld,evendx
        logical waveloop
        integer iangletype
        real*8 thetapminp,thetapmaxp,dthetapp
        namelist /addswitchs/interpms,useigeo,iangletype,chkdz,aureole,
     &thetapminp,thetapmaxp,dthetapp,thkcld,evendx,waveloop
c default values
cc
        ierr=0
	fname="flat.in"
        debug=.false.
        thkcldmin=0.5d0
        maxiflag=10
c
        open(51,file=fname,status='old')
c
C Read total optical depths for aerosol, rayleigh, water vapor, and
C ozone. Also read the wavelength.
        read(51,*) ttf, ttr, ttc, totoz, totwat, wavel
        if(debug)write(6,*) ttf, ttr, ttc, totoz, totwat, wavel
c
c aerosol stuff
c
        call rdsizedist(aerodist,maxiflag,debug,ierr)
        if(ierr.ne.0) goto 9999
c
c rayleigh stuff
c
c read the surface pressure and the King correction factor
        read(51,*) sfcprs,Fk
        if(debug)write(6,*) sfcprs,Fk
c
c cloud stuff
c
c read the cloud pressure levels
        read(51,*) pcldtop,pcldbot
        if(debug)write(6,*) pcldtop,pcldbot
c read the cloud size dist stuff
        call rdsizedist(clddist,maxiflag,debug,ierr)
        if(ierr.ne.0) goto 9999
c
c absorption stuff
c
c read the ozone absorption coe
	read(51,*) (o3coe(i),i=1,3)
	if(debug)write(6,*) (o3coe(i),i=1,3)
c read the water vapor absorption coe
	read(51,*) h2ocoe
	if(debug)write(6,*) h2ocoe
c
c info for dividing atmosphere
c
c read the atmosphere type and the gravity correction switchs
        read(51,*) iatmtype,lgcorrect
        if(debug)write(6,*) iatmtype,lgcorrect
c read the max delta tau of layer and the top of the atmosphere,
c logical switch for dave pressure scheme and the layer increament that
c is used in dave pressure scheme.
	read(51,*) dtaumax,top,daveps,ndl
	if(debug)write(6,*) dtaumax,top,daveps,ndl
        if(daveps)then
          if((ndl.ne.1).and.(ndl.ne.2).and.(ndl.ne.4).and.(ndl.ne.8)
     &.and.(ndl.ne.5).and.(ndl.ne.8).and.(ndl.ne.10).and.
     &(ndl.ne.20))then
            write(6,*)'divide. ndl must be 1,2,4,5,8,10 or 20.'
            write(6,*)'divide. will stop now (ndl=',ndl,')'
            ierr=4
            goto 9999
          endif
        endif
c
c info for running flatpsv subroutine
c
c read the number of iterations, # of polarization parameters, 
c and solar attenuation model
        read(51,*)npass,np,ipseudo
        if(debug)write(6,*)npass,np,ipseudo
        if(np.gt.4)then
          write(6,*)'read51. # of polarization parameters > 4'
          write(6,*)'read51. Will set # to 4'
          np=4
        endif
        if(ipseudo.gt.1)then
          write(6,*)'read51. Currently can only have pseudo-',
     &'spherical atmo'
          write(6,*)'read51. ipseudo is set to ',ipseudo
          write(6,*)'read51. Will set ipseudo=1 (pseudo-sph)'
          ipseudo=1
        else if(ipseudo.lt.0)then
          write(6,*)'read51. ipseudo is set to ',ipseudo
          write(6,*)'read51. Must be 0 or 1'
          write(6,*)'read51. Will set ipseudo=0 (flat)'
          ipseudo=0
        endif
c read the surface reflectance model and albedo
        read(51,*)isfc,refl
        if(debug)write(6,*)isfc,refl
c
        if(isfc.gt.4)then
          write(6,*)'read51. Currently must have isfc<5'
          write(6,*)'read51. So will set isfc=0'
          isfc=0
        endif
        if(isfc.eq.3)then
          backspace(51)
          read(51,*)isfc,vocean,pheevocean,refrocn,refiocn
          refl=1.0d0
          if(vocean.lt.0.0001)vocean=0.0001
        else if(isfc.eq.4)then
          backspace(51)
          read(51,*)isfc,refrocn,refiocn
          refl=1.0d0
        endif
        if(refl.gt.1.0d0)then
          write(6,*)'read51. reflectivity is greater than 1.0'
          write(6,*)'read51. will set refl=1.0'
          refl=1.0
        else if(refl.lt.0.0d0)then
          write(6,*)'read51. reflectivity is less than 0.0'
          write(6,*)'read51. will set refl=0.0'
          refl=0.0
        endif
c read the number of solar zenith angles
        read(51,*)nsun
        if(debug)write(6,*)nsun
        if(nsun.gt.12)then
          write(6,*)'read51. Must have # of solar zenith angles < 13'
          write(6,*)'read51. nsun=',nsun
          write(6,*)'read51. Will set nsun=12'
          nsun=12
        endif
c read the solar zenith angles
        read(51,*)(suns(i),i=1,nsun)
        if(debug)write(6,*)(suns(i),i=1,nsun)
c read the solar flux
        read(51,*)Fo
        if(debug)write(6,*)Fo
c
c info for output control
c
c read the print out angles
        read(51,*)lprttop,vthmintop,vthmaxtop,dvthtop,vphimintop,
     &vphimaxtop,dvphitop
        if(debug)write(6,*)lprttop,vthmintop,vthmaxtop,dvthtop,
     &vphimintop,vphimaxtop,dvphitop
        read(51,*)lprtbot,vthminbot,vthmaxbot,dvthbot,vphiminbot,
     &vphimaxbot,dvphibot
        if(debug)write(6,*)lprtbot,vthminbot,vthmaxbot,dvthbot,
     &vphiminbot,vphimaxbot,dvphibot
c read for printing out the forward direction
        read(51,*)doforward
        if(debug)write(6,*)doforward
c read for printing fluxes
        read(51,*)lprtflx
        if(debug)write(6,*)lprtflx
c
c if iatmtype eq 2 then, have an extra card with the mean alt and std of
c gaussian shaped aerosol vertical profile
c
        if(iatmtype.eq.2.or.iatmtype.eq.3)then
          read(51,*)aerz0,aersig
          if(debug)write(6,*)aerz0,aersig
          if(iatmtype.eq.3)read(51,*)deltaoz
        endif
        close(51)
c
c read the namelist if it exist
c
        inquire(file='addswitchs',exist=ex)
        if(ex)then
c initialize
          interpms=linterpms
          useigeo=luseigeo
          iangletype=iangtyp
          chkdz=lchkdz
          aureole=laureole
          thetapminp=thetapmin
          thetapmaxp=thetapmax
          dthetapp=dthetap
          thkcld=lthkcld
          waveloop=lwaveloop
c read and store
          open(51,file='addswitchs',status='old')
          read(51,addswitchs)
          close(51)
          linterpms=interpms
          luseigeo=useigeo
          iangtyp=iangletype
          lchkdz=chkdz
          laureole=aureole
          thetapmin=thetapminp
          thetapmax=thetapmaxp
          dthetap=dthetapp
          lthkcld=thkcld
          levendx=evendx
          lwaveloop=waveloop
          if(debug)write(6,*)'read51. linterpms= ',linterpms
          if(debug)write(6,*)'read51. luseigeo=  ',luseigeo
          if(debug)write(6,*)'read51. iangtyp=   ',iangtyp
          if(debug)write(6,*)'read51. lchkdz=   ',lchkdz
          if(debug)write(6,*)'read51. laureole=',laureole
          if(debug)write(6,*)'read51. thetapmin=',thetapmin
          if(debug)write(6,*)'read51. thetapmax=',thetapmax
          if(debug)write(6,*)'read51. dthetap=',dthetap
          if(debug)write(6,*)'read51. lthkcld=',lthkcld
        endif
c
9999    continue
        return
        end
C########################################################################
        subroutine rdsizedist(aerodist,maxiflag,debug,ierr)
c
c read the aerosol size dist. info (index of refraction, size dist type
c min and max radii and dist. parameters for evaluating dNdr.
c
c
c last modified: Nov. 18, 1996
c purpose: Add switch for Henyey-Greenstein phase function
c
c last modified: May 30, 1997
c purpose: Modify to allow for the aerodist(1)=0 case, which is no
c          size distribution and thus no aerosols.
c
c aerodist array contains the information concerning the size dist.
c
c aerodist(1)=iflag
c aerodist(2)=refre
c aerodist(3)=refim
c aerodist(4)=rmin
c aerodist(5)=rmax
c if(iflag.eq.1)then		! power law
c   aerodist(6)=anu
c else if(iflag.eq.2)then	! log-normal
c   aerodist(6)=sigma
c   aerodist(7)=rmean
c else if(iflag.eq.3)then	! modified gamma
c   aerodist(6)=a
c   aerodist(7)=b
c   aerodist(8)=alpha
c   aerodist(9)=gamma
c else if(iflag.eq.4)then	! double log-normal
c   aerodist(4)=rmin1
c   aerodist(5)=rmax1
c   aerodist(6)=sigma1
c   aerodist(7)=rmean1
c   aerodist(8)=Nc1
c   aerodist(9)=rmin2
c   aerodist(10)=rmax2
c   aerodist(11)=sigma2
c   aerodist(12)=rmean2
c   aerodist(13)=Nc2
c   aerodist(19)=refre2
c   aerodist(20)=refim2
c else if(iflag.eq.5)then	! triple log-normal
c   aerodist(4)=rmin1
c   aerodist(5)=rmax1
c   aerodist(6)=sigma1
c   aerodist(7)=rmean1
c   aerodist(8)=Nc1
c   aerodist(9)=rmin2
c   aerodist(10)=rmax2
c   aerodist(11)=sigma2
c   aerodist(12)=rmean2
c   aerodist(13)=Nc2
c   aerodist(14)=rmin3
c   aerodist(15)=rmax3
c   aerodist(16)=sigma3
c   aerodist(17)=rmean3
c   aerodist(18)=Nc3
c   aerodist(19)=refre2
c   aerodist(20)=refim2
c   aerodist(21)=refre3
c   aerodist(22)=refim3
c else if(iflag.eq.6)then	! HENYEY-GREENSTEIN
c   aerodist(6)=wo
c   aerodist(7)=g
c else if(iflag.eq.7)then	! T-Matrix file from tm2.f
c
c else if(iflag.eq.9)then       ! Power Law with input reff and veff will 
c                               ! set anu=2.0 and calc the min and max radii
c                               ! using Mich's program from tm2.f.
c                               ! read the values of veff & reff
c   aerodist(6)=anu
c else if(iflag.eq.10)then
c                               ! LOG-NORMAL with input reff and veff will
c                               ! solve for rmean sigma along with the min
c                               ! and max radii based upon 
c                               ! ln(rmin_max)=ln(rmean)+/-n_sigma*sigma 
c                               ! read the values of veff & reff and 
c                               ! the # of sigmas for rmin,rmax (n_sigma)
c   aerodist(6)=sigma
c   aerodist(7)=rmean
c endif
        implicit none
        real*8 aerodist(22)
        integer i,nrd,j,k,maxiflag,ierr
        logical debug
        character*1 buf
        real*8 rmin,rmax,reff,veff,sigma_factor
c
c read the aerosol size dist type
        read(51,*) aerodist(1)
        if(debug)write(6,*) aerodist(1)
c
c if no size distribution, then put zeroes in the rest of the array
c
        i=int(aerodist(1)+0.1)
        if(i.eq.0)then
          do i=2,22
             aerodist(i)=0.0
          enddo
          do i=1,3
             read(51,'(a)')buf
          enddo
          return
        else if(i.gt.maxiflag)then
          write(6,1000)i,maxiflag
          write(6,*)'rdsizedist. Will stop now.'
          ierr=1
          return
1000      format(' rdsizedist. Input size dist flag ',i3,
     &' is greater than the maximum flag of ',i3,'.')
        endif
c read the aerosol index of refraction
        if((aerodist(1).le.3).or.(aerodist(1).eq.9).or.
     &(aerodist(1).eq.10))then
          read(51,*) aerodist(2),aerodist(3)
          if(debug)write(6,*) aerodist(2),aerodist(3)
        else if(aerodist(1).eq.4)then
          read(51,*) aerodist(2),aerodist(3),aerodist(19),aerodist(20)
          if(debug)write(6,*) aerodist(2),aerodist(3),aerodist(19),
     &aerodist(20)
        else if(aerodist(1).eq.5)then
          read(51,*) aerodist(2),aerodist(3),aerodist(19),aerodist(20),
     &aerodist(21),aerodist(22)
          if(debug)write(6,*) aerodist(2),aerodist(3),aerodist(19),
     &aerodist(20),aerodist(21),aerodist(22)
        else if(aerodist(1).eq.6)then
          read(51,'(a)')buf
          aerodist(2)=0.0
          aerodist(3)=0.0
        else if(aerodist(1).eq.7)then
          read(51,'(a)')buf
          read(51,'(a)')buf
          read(51,'(a)')buf
          return
        endif
c read the min and max radii
        if((aerodist(1).le.3).or.(aerodist(1).eq.9).or.
     &(aerodist(1).eq.10))then
          read(51,*)aerodist(4),aerodist(5)
          if(debug)write(6,*) aerodist(4),aerodist(5)
        else if(aerodist(1).eq.4)then
          read(51,*)aerodist(4),aerodist(5),aerodist(9),aerodist(10)
          if(debug)write(6,*)aerodist(4),aerodist(5),
     &aerodist(9),aerodist(10)
        else if(aerodist(1).eq.5)then
          read(51,*)(aerodist(4+i),aerodist(5+i),i=0,10,5)
          if(debug)write(6,*)(aerodist(4+i),aerodist(5+i),i=0,10,5)
        else if(aerodist(1).eq.6)then
          read(51,'(a)')buf
          aerodist(4)=0.0
          aerodist(5)=0.0
        endif
c read the size dist. parameters
        if((aerodist(1).le.2))then
          nrd=2
          read(51,*)(aerodist(5+i),i=1,nrd)
          if(debug)write(6,*) (aerodist(5+i),i=1,nrd)
        else if(aerodist(1).eq.3)then
          nrd=nint(aerodist(1))+1
          read(51,*)(aerodist(5+i),i=1,nrd)
          if(debug)write(6,*) (aerodist(5+i),i=1,nrd)
        else if(aerodist(1).eq.4)then
          nrd=3
          read(51,*)(aerodist(5+i),i=1,nrd),(aerodist(10+j),j=1,nrd)
          if(debug)write(6,*)(aerodist(5+i),i=1,nrd),
     &(aerodist(10+j),j=1,nrd)
        else if(aerodist(1).eq.5)then
          nrd=3
          read(51,*)(aerodist(5+i),i=1,nrd),
     &(aerodist(10+j),j=1,nrd),(aerodist(15+k),k=1,nrd)
          if(debug)write(6,*)(aerodist(5+i),i=1,nrd),
     &(aerodist(10+j),j=1,nrd),(aerodist(15+k),k=1,nrd)
        else if(aerodist(1).eq.6)then
          read(51,*)(aerodist(5+i),i=1,2)
          if(debug)write(6,*) (aerodist(5+i),i=1,2)
        else if(aerodist(1).eq.9)then
c power law with input reff and veff will set anu=2.0 and calc
c the min and max radii using Mich's program from tm2.f
c read the values of veff & reff
          nrd=2
          read(51,*)(aerodist(5+i),i=1,nrd)
          if(debug)write(6,*)(aerodist(5+i),i=1,nrd)
c now calc. rmin,rmax
          call power_law(aerodist(7),aerodist(6),aerodist(4),
     &aerodist(5))
c radii
          if(debug)write(6,*)aerodist(4),aerodist(5)
c set the power equal to 2.0
          aerodist(6)=2.0
c set flag to power law
          aerodist(1)=1
c set the break-point radius between constant number density and power law portion
c equal to the minimum radius
          aerodist(7)=aerodist(4)
        else if(aerodist(1).eq.10)then
c log-normal with input reff and veff will solve for rmean sigma
c along with the min and max radii based upon ln(rmin_max)=ln(rmean)+/-4*sigma
c read the values of veff & reff and the # of sigmas for rmin,rmax
          nrd=3
          read(51,*)(aerodist(5+i),i=1,nrd)
          sigma_factor=aerodist(8)
          if(debug)write(6,*)(aerodist(5+i),i=1,nrd)
          veff=aerodist(6)
          aerodist(6)=sqrt(log(veff+1.0d0))
          reff=aerodist(7)
          write(6,*)'read51. veff,reff ',veff,reff
          aerodist(7)=reff*exp(-2.5d0*aerodist(6)*aerodist(6))
          write(6,*)'read51. 6 7 ',aerodist(6),aerodist(7)
c now calc. rmin,rmax
          rmin=exp(log(aerodist(7))-sigma_factor*aerodist(6))
          rmax=exp(log(aerodist(7))+sigma_factor*aerodist(6))
          aerodist(6)=exp(aerodist(6))
          aerodist(4)=rmin
          aerodist(5)=rmax
c radii
          if(debug)write(6,*)aerodist(4),aerodist(5)
c set flag to log normal
          aerodist(1)=2
        endif
        return
        end
