c $Header: /usr/people/flittner/radtran/flatpsv/src/sfcrho.f,v 1.14 1999/08/16 18:59:08 flittner Exp flittner $
************************************************************************
	subroutine sfcrho(
     &npass,ndownlos,nz,nlos,np,Fu,esi0r,esingr,
     &deltmu,dmu,costh,sinth,wa,wr,wc,pal,trans,dt,convrg,Fd,Futop,
     &fmatrx,rmatrx,cmatrx,gamma,aniso,itlmax,
     &mingeoit,luseigeo,geoconvrg,lefd,lefu)
************************************************************************
C----------------------------------------------------------------------
C THIS PROGRAM CALCULATES MULTIPLE SCATTERING INTENSITIES AT ALL
C LEVELS ON THE ZENITH FOR A SET OF INPUT THETAS, TYPICALLY =5,15,25,...175
c due to an isotropic upward intensity at the surface.
c***********************************************************************
c NOTE: TO CHANGE NUMBER OF LEVELS, CHANGE NZ=NUMBER OF LEVELS IN ALL
C       THE PARAMETER STATEMENTS IN THIS PROGRAM AND ALL OTHER PROGRAMS
C VARIABLES IN THE PROGRAM
C      TABS(I),TF(I),TRAY(I)= DELTA TAU (FOR ABSORPTION (O3+H2O), AEROSOL,
C                             RAYLEIGH)
C      DT(I)=TOTAL DELTA TAU OF EACH LAYER
C      DF=DELTA PHI IN RADIANS
C      TH(I)=SCATTERING ANGLES IN RADIANS
C      THD(I)=THETA(I) IN DEGRRES arranged in ascending order
C      ESI0R(m,I,L)=INTENSITY AT LEVEL Z(L) ON THE ZENITH FOR THETA(I)
C                  and polarization element m. Includes surface reflection term.
C      ESING0(m,J,I,L) = SINGLE SCATTERING INTENSITIES. THE SINGLE SCATTERING 
C                      VALUES  DO NOT INCLUDE REFLECTIVITY CONTRIBUTION
C      PAL(I,L)=OPTICAL DEPTH ALONG L.O.S STARTING AT LEVEL Z(L) ON THE
C               ZENITH AT AN ANGLE THETA(I). 
C               A) IF THETA(I) IS LESS THAN 90 THEN THE THE OPTICAL DEPTH IS 
C                  BETWEEN LEVEL Z(L) AND Z(L-1) I.E FOR LAYER L-1 (THE 
C                  LAYER ABOVE Z(L))
C               B)IF THETA(I) IS GREATER THAN 90 THEN THE OPTICAL DEPTH IS 
C                 BETWEEN LEVEL Z(L+1) AND Z(L) I.E. FOR LAYER L (THE LAYER 
C                 BELOW Z(L))
C      NPASS = MAXIMUM NUMBER OF ITERATION TO BE PERFORMED
C      SUN = THETA0 (IN DEGREES) OF THE SUN (MEASURED FROM THE ZENITH)
C      NLOS = NO. OF OBSERVATION ANGLES (I.E. NO OF THETA'S) ,SHOULD BE NANG
C      MLOS = max num of nlos possible
C      NZ = NO OF LEVELS IN THE ATMOSPHERE (INCLUDING THE SURFACE (LEVEL NZ)
C      NFI = NO. OF PHI'S SHOULD BE 7 (DELTA PHI IS 30 AND THEREFORE 7 PHI'S
C            GIVE PHI=0,30,60,...,180
C      DR = CONVERSION BETWEEN DEGREES TO RADIANS
C      SFLX0(I) = THE SOLAR FLUX (F0) CROSSING THROUGH LEVEL I ON THE ZENITH
C      DFLUX(I) = DOWNWARD FLUX CROSSING LEVEL I. ON THE ZENITH
C      UFLUX(I) = UPWARD FLUX CROSSING LEVEL I. ON THE ZENITH
C      NP = number of polarization parameters to be computed (1,2,3, or 4).
C
      implicit none
      include 'param.inc'
      include 'consts.cmn'
      include 'catmdata.cmn'
c mlos= maximum number of line of sight anlges
c variables that are passed
	integer npass,ndownlos,nz,nlos,np,itlmax,mingeoit
	real*8  upflux,dnflux,pnigne,Fu
	real*8 esi0r(4,mlos,maxnz),esingr(4,mlos,maxnz),
     &	deltmu(mlos),dmu(mlos),
     &	costh(mlos),sinth(mlos),
     &	fmatrx(4,4,nfi,mlos,mlos),
     &  rmatrx(4,4,nfi,mlos,mlos),
     &  cmatrx(4,4,nfi,mlos,mlos),
     &	pal(mlos,maxnz),trans(mlos,maxnz),dt(maxnlayr),convrg,
     &  wa(maxnlayr),wr(maxnlayr),gamma,wc(maxnlayr),geoconvrg
        logical aniso,luseigeo,lefd,lefu
c ouput
        real*8 Fd,Futop
c functions
        integer igsunt
        real*8 fluxr
c external
        external fluxr,igsunt
c variables that are local
	integer iend,itest,L,idflag
	real*8  ratio,energy,enginp
        real*8 Pr0mat(4,4,mlos,mlos)
        real*8 Pf0mat(4,4,mlos,mlos)
        real*8 Pc0mat(4,4,mlos,mlos)
        logical forview,ldown
c
c geometric series
        integer iunt,igeoindx(3),naz
        logical finishi,finishf
        real*8 fluxes(3,2)
c
c
C*************************************************************************
c set switches for geometric series
      finishi=.FALSE.
      finishf=.FALSE.
      igeoindx(1)=71
      igeoindx(2)=72
      igeoindx(3)=73
      naz=1
      enginp=Fu
      pnigne=1.0d0/enginp
C PREFORM GAUSS-SIDEL ITERATION SCHEME  
C SINGLE SCATTERING AT ALL LEVELS AND LINES OF SIGHT IS COMPUTED ON THE
C FIRST PASS OF THE ITERATION SCHEME. ON SUBSEQUENT PASSES, SUBROUTINES
C DOWNIT AND UPIT ARE USED TO COMPUTE THE UPWARD AND DOWNWARD INTENSITIES
C FROM MULTIPLE SCATTERING

      iend=0
      write(*,9000)iend,npass
      itest=0
      write(6,*) ' COMPUTE SINGLE SCATTER INTENSITIES'
      call cmpsngr(ndownlos,nlos,np,nz,costh,dt,Fu,esi0r,esingr)
      L=nz
      idflag=0
      dnflux=fluxr(L,ndownlos,esi0r,deltmu,nz,nlos,np,idflag)
      write(6,'(a40,1PE12.4)')
     &'the downward flux at the surface is ',dnflux
      L=1
      idflag=1
      upflux=fluxr(L,ndownlos,esi0r,deltmu,nz,nlos,np,idflag)
      energy=dabs(dnflux)+dabs(upflux)
      ratio=energy*pnigne
      write(6,'(a40,1PE12.4)')
     &'the upward flux at the top of atmo. is ',upflux

c average the phase matrix over azimuth angles
      if(rayleigh)then
        forview=.FALSE.
	call avgrayphs(costh,sinth,dmu,rmatrx,
     &gamma,nlos,np,aniso,Pr0mat,forview)
      endif
      if(aerosol)then
        forview=.FALSE.
        call avgphsphi(fmatrx,nlos,forview,Pf0mat)
      endif
      if(cloud)then
        forview=.FALSE.
        call avgphsphi(cmatrx,nlos,forview,Pc0mat)
      endif
      write(6,'(a50,1PE12.4)')
     &'the ratio of flux out to flux into the atmo. is ',ratio

      write(61,1000)iend,enginp,energy,ratio
      write(61,2000)dnflux,upflux
c
c multiple scatter
c
      do 60 iend=1,npass
         write(*,9000)iend,npass
         itest=0
         write(6,*)' COMPUTE DOWNWARD INTENSITIES' 
         ldown=.TRUE.
         call downitr(itest,ndownlos,esi0r,esingr,pal,dmu,ldown,
     &wa,wr,wc,Pf0mat,Pr0mat,Pc0mat,trans,nz,nlos,np,convrg,itlmax)
         L=nz
         idflag=0
         dnflux=fluxr(L,ndownlos,esi0r,deltmu,nz,nlos,np,idflag)
         write(6,'(a40,1PE12.4)')
     &'the downward flux at the surface is ',dnflux

         write(6,*)' COMPUTE UPWARD INTENSITIES' 
         ldown=.FALSE.
         call downitr(itest,ndownlos,esi0r,esingr,pal,dmu,ldown,
     &wa,wr,wc,Pf0mat,Pr0mat,Pc0mat,trans,nz,nlos,np,convrg,itlmax)
         L=1
         idflag=1
         upflux=fluxr(L,ndownlos,esi0r,deltmu,nz,nlos,np,idflag)
         energy=dabs(dnflux)+dabs(upflux)
         ratio=energy*pnigne
         write(6,'(a40,1PE12.4)')
     &'the upward flux at the top of atmo. is ',upflux
         write(6,'(a50,1PE12.4)')
     &'the ratio of flux out to flux into the atmo. is ',ratio

         write(61,1000)iend,enginp,energy,ratio
         write(61,2000)dnflux,upflux
c store fluxes at boundarys
         if(iend.eq.1)then
           fluxes(1,1)=dnflux
           fluxes(1,2)=upflux
         else if(iend.eq.2)then
           fluxes(2,1)=dnflux
           fluxes(2,2)=upflux
         else if(iend.eq.3)then
           fluxes(3,1)=dnflux
           fluxes(3,2)=upflux
         else
           fluxes(1,1)=fluxes(2,1)
           fluxes(1,2)=fluxes(2,2)
           fluxes(2,1)=fluxes(3,1)
           fluxes(2,2)=fluxes(3,2)
           fluxes(3,1)=dnflux
           fluxes(3,2)=upflux
         endif

         if(itest.eq.0) then
           write(6,'(a34,1pe7.1,a48)') 
     &' INTENSITIES CHANGED BY LESS THAN ',convrg,
     &'% --  SOLUTION CONVERGED ENDING ITERATION SCHEME'
	      go to 70
         end if
         if(luseigeo.and.(iend.gt.(mingeoit-3)))then
c save iteration values to temperay file
           iunt=70+igsunt(iend)
           open(iunt,status='scratch')
           call wrtesi0(esi0r,nlos,nz,naz,np,iunt)
           call rotindx(igeoindx)
         else if(luseigeo)then
           call rotindx(igeoindx)
         endif
         if(iend.ge.mingeoit)then
           call chkfgeo(geoconvrg,finishf,fluxes,lefd,lefu)
c check the intensity geometric series to see if can quit now.
           if(finishf.and.luseigeo)then
             call chkigeo(mlos,maxnz,naz,nlos,
     &nz,np,igeoindx,geoconvrg,finishi,esi0r)
           else
             if(luseigeo)then
               close(igeoindx(1))
             endif
           endif
         endif
         if(finishi)then
           write(6,*)'sfcrho. Will use geometric series to finish ',
     &'the iterations'
           L=nz
           idflag=0
           dnflux=fluxr(L,ndownlos,esi0r,deltmu,nz,nlos,np,idflag)
           L=1
           idflag=1
           upflux=fluxr(L,ndownlos,esi0r,deltmu,nz,nlos,np,idflag)
           energy=dabs(dnflux)+dabs(upflux)
           ratio=energy*pnigne
           write(6,'(a40,1PE12.4)')
     &'the downward flux at the surface is ',dnflux
           write(6,'(a40,1PE12.4)')
     &'the upward flux at the top of atmo. is ',upflux
           write(6,'(a50,1PE12.4)')
     &'the ratio of flux out to flux into the atmo. is ',ratio
           write(61,1000)iend+1,enginp,energy,ratio
           write(61,2000)dnflux,upflux
           goto 70
         endif
 60   continue
 70   continue
      if(luseigeo)then
        close(igeoindx(1))
        close(igeoindx(2))
        close(igeoindx(3))
      endif
      Fd=dnflux
      Futop=upflux


1000  format(1x,'ITERATION NO ',i4,/,1x,' ENRG INP=',1Pe11.4,
     &' ENRG OUT=',1Pe11.4,' ENRG OUT/ENRG INP=',1Pe11.4)
2000  format(5x,'DFLUX=',1Pe11.4,' UPFLUX= ',1Pe11.4)
9000  format(1x,'----------',16x,'ITERATION ',i4,' OUT OF ',i4,
     &         17x,'----------')

      write(61,*)
      write(61,*)
      write(61,*)
      write(61,*)
c
      return
      end
************************************************************************
