c $Header: /usr/people/flittner/radtran/flatpsv/src/source.f,v 1.16 2000/07/29 00:15:41 flittner Exp flittner $
c ---------------------------------------------------------------------

      subroutine source(lcurent,layer,lprevious,i,j,esi0,dmu,
     &wal,wrl,wcl,cf1,cf2,fmatrx,rmatrx,cmatrx,nlos,np,enew,debug0)

C This routine performs the integral of the source function (diffuse, 
C including single scattering) over tau in layer for l.o.s originating
C in level lcurent (observation level) at an angle theta, index i,
C and phi, index j.
C The source function is P*I*domega (integrated over omega).
C set theta' (input) for integration over all phi' (inputs) 
C Use symmetry of esi0 and phase matrix for phi'>180 in 
C calculating the source in a given output direction.
C f1 = intensity at level lprevious, f1=P*i(lprevious)
C f2 = intensity at level lcurent, f2=P*I(lcurent)
C f  = the integral of the intensity along l.o.s between level lcurent
C      and lprevious (i.e layer ) = integral over delta tau of 
C      P*I*exp(tau/mu) dtau/mu
c enew = F * domega
C pn = the phase function for the layer
C wal = layer aerosol optical depth divided by total layer optical depth
C wrl = layer rayleigh optical depth divided by total layer optical depth
c
C transform index kfmat for azimuth diference in phasems(i,j,kfmat) if the 
C     azimuth difference is greater than 180 degrees 
c
      implicit none
      include 'param.inc'
      include 'consts.cmn'
c variables that are passed
      integer lcurent,layer,lprevious,i,j,nlos,np
      real*8 esi0(4,nfi,mlos,maxnz),dmu(mlos),cf1,cf2,
     &enew(4),fmatrx(4,4,nfi,mlos,mlos),rmatrx(4,4,nfi,mlos,mlos),
     &cmatrx(4,4,nfi,mlos,mlos),wal,wrl,wcl
	logical debug,debug0
c variables that are local
      integer jprim,mm,kfmat,nn,n,m,nfip1,jl,jr,isr,isl
      real*8 f2,f1,f,ep(4),ec(4),pn(4,4),ddomeg
	character ans*1
c      data debug/.FALSE./
c      save debug
c
      debug=.false.
      do m=1,np
         enew(m)=0.0d0
      enddo
      nfip1=nfi+1
      if((j.eq.1).or.(j.eq.nfi))then
c integrate over theta incident
         do jprim=1,nlos
            ddomeg=df*dmu(jprim)
            if(debug0.and.jprim.eq.15)then
              debug=.true.
            else
              debug=.false.
            endif
	if(debug)write(6,*)'s. jprim',jprim,ddomeg
c integrate over delta phi incident
c if phi out is equal to zero use symmetry about the solar plane for I1 and
c I2, and neg. symmetry for I3 and I4.  Also have neg. symmetry in Phase matrix
c for the upper right four elements and the lower left four elements.
c
c forward scattering:kfmat=1
            do n=1,np
               do m=1,np
                  pn(m,n)=wal*fmatrx(m,n,1,jprim,i)+
     &wrl*rmatrx(m,n,1,jprim,i)+
     &wcl*cmatrx(m,n,1,jprim,i)
               enddo
            enddo
	if(debug)write(6,*)'s. pn',1,pn
            nn=j
            do n=1,np
               ep(n)=esi0(n,nn,jprim,lprevious)
               ec(n)=esi0(n,nn,jprim,lcurent)
            enddo
	if(debug)write(6,*)'s. ep',ep
	if(debug)write(6,*)'s. ec',ec
            do m=1,np
               f1=pn(m,1)*ep(1)
               f2=pn(m,1)*ec(1)
               do n=2,np
                  f1=f1+pn(m,n)*ep(n)
                  f2=f2+pn(m,n)*ec(n)
               enddo
               f=f1*cf1
               f=f+f2*cf2
               enew(m)=enew(m)+f*ddomeg
	if(debug)write(6,*)'s. enew',enew(m)
            enddo
c backscattering: kfmat=nfi
            do n=1,np
               do m=1,np
                  pn(m,n)=wal*fmatrx(m,n,nfi,jprim,i)+
     &wrl*rmatrx(m,n,nfi,jprim,i)+
     &wcl*cmatrx(m,n,nfi,jprim,i)
               enddo
            enddo
	if(debug)write(6,*)'s. pn',nfi,pn
            if(j.eq.1)then
               nn=nfi
            else
               nn=1
            endif
            do n=1,np
               ep(n)=esi0(n,nn,jprim,lprevious)
               ec(n)=esi0(n,nn,jprim,lcurent)
            enddo
	if(debug)write(6,*)'s. ep',ep
	if(debug)write(6,*)'s. ec',ec
            do m=1,np
               f1=pn(m,1)*ep(1)
               f2=pn(m,1)*ec(1)
               do n=2,np
                  f1=f1+pn(m,n)*ep(n)
                  f2=f2+pn(m,n)*ec(n)
               enddo
               f=f1*cf1
               f=f+f2*cf2
               enew(m)=enew(m)+f*ddomeg
            enddo
	if(debug)write(6,*)'s. enew',enew(1)
c integrate over delta phi incident
c if phi out is equal to zero use pos. symmetry about the solar plane for I1 and
c I2, and neg. symmetry for I3 and I4.  Also have neg. symmetry in Phase matrix
c for the upper right four elements and the lower left four elements.
            ddomeg=ddomeg*2.0d0
            do 40 kfmat=2,nfi-1
               do 20 n=1,np
                  pn(1,n)=wal*fmatrx(1,n,kfmat,jprim,i)+
     &wrl*rmatrx(1,n,kfmat,jprim,i)+
     &wcl*cmatrx(1,n,kfmat,jprim,i)
                  pn(2,n)=wal*fmatrx(2,n,kfmat,jprim,i)+
     &wrl*rmatrx(2,n,kfmat,jprim,i)+
     &wcl*cmatrx(2,n,kfmat,jprim,i)
20             continue
               if(j.eq.nfi)then
                  nn=nfip1-kfmat
               else
                  nn=kfmat
                  pn(1,3)=-pn(1,3)
                  pn(1,4)=-pn(1,4)
                  pn(2,3)=-pn(2,3)
                  pn(2,4)=-pn(2,4)
               end if
	if(debug)write(6,*)'s. pn kfmat',kfmat,pn
               do n=1,np
                  ep(n)=esi0(n,nn,jprim,lprevious)
                  ec(n)=esi0(n,nn,jprim,lcurent)
               enddo
c m=1
	if(debug)write(6,*)'s. ep',ep
	if(debug)write(6,*)'s. ec',ec
               f1=pn(1,1)*ep(1)
               f2=pn(1,1)*ec(1)
               do n=2,np
                  f1=f1+pn(1,n)*ep(n)
                  f2=f2+pn(1,n)*ec(n)
               enddo
               f=f1*cf1
               f=f+f2*cf2
               enew(1)=enew(1)+f*ddomeg
	if(debug)write(6,*)'s. enew',enew(1)
c m=2
               if(np.ge.2)then
                  f1=pn(2,1)*ep(1)
                  f2=pn(2,1)*ec(1)
                  do n=2,np
                     f1=f1+pn(2,n)*ep(n)
                     f2=f2+pn(2,n)*ec(n)
                  enddo
                  f=f1*cf1
                  f=f+f2*cf2
                  enew(2)=enew(2)+f*ddomeg
               endif
40          continue
         enddo 
	if(debug)then
          write(6,*)'s continue ',i
        read(5,'(a)')ans
        endif
      else
c output phi is not 0.0 or 180.0
c integrate over theta incident
         do 80 jprim=1,nlos
            ddomeg=df*dmu(jprim)
c integrate over delta phi incident
c
c forward scatter case: kfmat=1
            do n=1,np
               do m=1,np
                  pn(m,n)=wal*fmatrx(m,n,1,jprim,i)+
     &wrl*rmatrx(m,n,1,jprim,i)+
     &wcl*cmatrx(m,n,1,jprim,i)
               enddo
            enddo
            do n=1,np
               ep(n)=esi0(n,j,jprim,lprevious)
               ec(n)=esi0(n,j,jprim,lcurent)
            enddo
            do m=1,np
               f1=pn(m,1)*ep(1)
               f2=pn(m,1)*ec(1)
               do n=2,np
                  f1=f1+pn(m,n)*ep(n)
                  f2=f2+pn(m,n)*ec(n)
               enddo
               f=f1*cf1
               f=f+f2*cf2
               enew(m)=enew(m)+f*ddomeg
            enddo
c
c loop for scattering angles dphi to (nfi-1)*dphi
            do kfmat=2,nfi-1
c load the scattering matrix
               do n=1,np
                  do m=1,np
                     pn(m,n)=wal*fmatrx(m,n,kfmat,jprim,i)+
     &wrl*rmatrx(m,n,kfmat,jprim,i)+
     &wcl*cmatrx(m,n,kfmat,jprim,i)
                  enddo
               enddo
c now load the radiance values
c index for scattering from the left
               jl=j-(kfmat-1)
c index for scattering from the right
               jr=j+(kfmat-1)
c now check to see what side the values are one
               if(jl.lt.1)then
                 jl=(1-jl)+1
                 isl=-1
               else
                 isl=1
               endif
               if(jr.gt.nfi)then
                 jr=nfi-(jr-nfi)
                 isr=-1
               else
                 isr=1
               endif
c now for the multiplication
c 
               if(np.eq.1)then
c np=1
                 f1=pn(1,1)*(esi0(1,jl,jprim,lprevious)+
     &esi0(1,jr,jprim,lprevious))
                 f2=pn(1,1)*(esi0(1,jl,jprim,lcurent)+
     &esi0(1,jr,jprim,lcurent))
                 enew(1)=enew(1)+(f1*cf1+f2*cf2)*ddomeg
               else if(np.eq.2)then
c np=2
                 ep(1)=esi0(1,jl,jprim,lprevious)+
     &esi0(1,jr,jprim,lprevious)
                 ep(2)=esi0(2,jl,jprim,lprevious)+
     &esi0(2,jr,jprim,lprevious)
                 ec(1)=esi0(1,jl,jprim,lcurent)+
     &esi0(1,jr,jprim,lcurent)
                 ec(2)=esi0(2,jl,jprim,lcurent)+
     &esi0(2,jr,jprim,lcurent)
                 f1=pn(1,1)*ep(1)+pn(1,2)*ep(2)
                 f2=pn(1,1)*ec(1)+pn(1,2)*ec(2)
                 enew(1)=enew(1)+(f1*cf1+f2*cf2)*ddomeg
                 f1=pn(2,1)*ep(1)+pn(2,2)*ep(2)
                 f2=pn(2,1)*ec(1)+pn(2,2)*ec(2)
                 enew(2)=enew(2)+(f1*cf1+f2*cf2)*ddomeg
               else if(np.eq.3)then
c np=3
                 ep(1)=esi0(1,jl,jprim,lprevious)+
     &esi0(1,jr,jprim,lprevious)
                 ep(2)=esi0(2,jl,jprim,lprevious)+
     &esi0(2,jr,jprim,lprevious)
                 ec(1)=esi0(1,jl,jprim,lcurent)+
     &esi0(1,jr,jprim,lcurent)
                 ec(2)=esi0(2,jl,jprim,lcurent)+
     &esi0(2,jr,jprim,lcurent)
                 if((isl.eq.1).and.(isr.eq.1))then
                   ep(3)=esi0(3,jl,jprim,lprevious)-
     &esi0(3,jr,jprim,lprevious)
                   ec(3)=esi0(3,jl,jprim,lcurent)-
     &esi0(3,jr,jprim,lcurent)
                 else if((isl.eq.1).and.(isr.eq.-1))then
                   ep(3)=esi0(3,jl,jprim,lprevious)+
     &esi0(3,jr,jprim,lprevious)
                   ec(3)=esi0(3,jl,jprim,lcurent)+
     &esi0(3,jr,jprim,lcurent)
                 else if((isl.eq.-1).and.(isr.eq.1))then
                   ep(3)=-esi0(3,jl,jprim,lprevious)-
     &esi0(3,jr,jprim,lprevious)
                   ec(3)=-esi0(3,jl,jprim,lcurent)-
     &esi0(3,jr,jprim,lcurent)
                 else if((isl.eq.-1).and.(isr.eq.-1))then
                   ep(3)=-esi0(3,jl,jprim,lprevious)+
     &esi0(3,jr,jprim,lprevious)
                   ec(3)=-esi0(3,jl,jprim,lcurent)+
     &esi0(3,jr,jprim,lcurent)
                 endif
                 f1=pn(1,1)*ep(1)+pn(1,2)*ep(2)+pn(1,3)*ep(3)
                 f2=pn(1,1)*ec(1)+pn(1,2)*ec(2)+pn(1,3)*ec(3)
                 enew(1)=enew(1)+(f1*cf1+f2*cf2)*ddomeg
                 f1=pn(2,1)*ep(1)+pn(2,2)*ep(2)+pn(2,3)*ep(3)
                 f2=pn(2,1)*ec(1)+pn(2,2)*ec(2)+pn(2,3)*ec(3)
                 enew(2)=enew(2)+(f1*cf1+f2*cf2)*ddomeg
                 ep(1)=esi0(1,jl,jprim,lprevious)-
     &esi0(1,jr,jprim,lprevious)
                 ep(2)=esi0(2,jl,jprim,lprevious)-
     &esi0(2,jr,jprim,lprevious)
                 ec(1)=esi0(1,jl,jprim,lcurent)-
     &esi0(1,jr,jprim,lcurent)
                 ec(2)=esi0(2,jl,jprim,lcurent)-
     &esi0(2,jr,jprim,lcurent)
                 if((isl.eq.1).and.(isr.eq.1))then
                   ep(3)=esi0(3,jl,jprim,lprevious)+
     &esi0(3,jr,jprim,lprevious)
                   ec(3)=esi0(3,jl,jprim,lcurent)+
     &esi0(3,jr,jprim,lcurent)
                 else if((isl.eq.1).and.(isr.eq.-1))then
                   ep(3)=esi0(3,jl,jprim,lprevious)-
     &esi0(3,jr,jprim,lprevious)
                   ec(3)=esi0(3,jl,jprim,lcurent)-
     &esi0(3,jr,jprim,lcurent)
                 else if((isl.eq.-1).and.(isr.eq.1))then
                   ep(3)=-esi0(3,jl,jprim,lprevious)+
     &esi0(3,jr,jprim,lprevious)
                   ec(3)=-esi0(3,jl,jprim,lcurent)+
     &esi0(3,jr,jprim,lcurent)
                 else if((isl.eq.-1).and.(isr.eq.-1))then
                   ep(3)=-esi0(3,jl,jprim,lprevious)-
     &esi0(3,jr,jprim,lprevious)
                   ec(3)=-esi0(3,jl,jprim,lcurent)-
     &esi0(3,jr,jprim,lcurent)
                 endif
                 f1=pn(3,1)*ep(1)+pn(3,2)*ep(2)+pn(3,3)*ep(3)
                 f2=pn(3,1)*ec(1)+pn(3,2)*ec(2)+pn(3,3)*ec(3)
                 enew(3)=enew(3)+(f1*cf1+f2*cf2)*ddomeg
               else if(np.eq.4)then
c np=4
                 ep(1)=esi0(1,jl,jprim,lprevious)+
     &esi0(1,jr,jprim,lprevious)
                 ep(2)=esi0(2,jl,jprim,lprevious)+
     &esi0(2,jr,jprim,lprevious)
                 ec(1)=esi0(1,jl,jprim,lcurent)+
     &esi0(1,jr,jprim,lcurent)
                 ec(2)=esi0(2,jl,jprim,lcurent)+
     &esi0(2,jr,jprim,lcurent)
                 if((isl.eq.1).and.(isr.eq.1))then
                   ep(3)=esi0(3,jl,jprim,lprevious)-
     &esi0(3,jr,jprim,lprevious)
                   ec(3)=esi0(3,jl,jprim,lcurent)-
     &esi0(3,jr,jprim,lcurent)
                   ep(4)=esi0(4,jl,jprim,lprevious)-
     &esi0(4,jr,jprim,lprevious)
                   ec(4)=esi0(4,jl,jprim,lcurent)-
     &esi0(4,jr,jprim,lcurent)
                 else if((isl.eq.1).and.(isr.eq.-1))then
                   ep(3)=esi0(3,jl,jprim,lprevious)+
     &esi0(3,jr,jprim,lprevious)
                   ec(3)=esi0(3,jl,jprim,lcurent)+
     &esi0(3,jr,jprim,lcurent)
                   ep(4)=esi0(4,jl,jprim,lprevious)+
     &esi0(4,jr,jprim,lprevious)
                   ec(4)=esi0(4,jl,jprim,lcurent)+
     &esi0(4,jr,jprim,lcurent)
                 else if((isl.eq.-1).and.(isr.eq.1))then
                   ep(3)=-esi0(3,jl,jprim,lprevious)-
     &esi0(3,jr,jprim,lprevious)
                   ec(3)=-esi0(3,jl,jprim,lcurent)-
     &esi0(3,jr,jprim,lcurent)
                   ep(4)=-esi0(4,jl,jprim,lprevious)-
     &esi0(4,jr,jprim,lprevious)
                   ec(4)=-esi0(4,jl,jprim,lcurent)-
     &esi0(4,jr,jprim,lcurent)
                 else if((isl.eq.-1).and.(isr.eq.-1))then
                   ep(3)=-esi0(3,jl,jprim,lprevious)+
     &esi0(3,jr,jprim,lprevious)
                   ec(3)=-esi0(3,jl,jprim,lcurent)+
     &esi0(3,jr,jprim,lcurent)
                   ep(4)=-esi0(4,jl,jprim,lprevious)+
     &esi0(4,jr,jprim,lprevious)
                   ec(4)=-esi0(4,jl,jprim,lcurent)+
     &esi0(4,jr,jprim,lcurent)
                 endif
                 f1=pn(1,1)*ep(1)+pn(1,2)*ep(2)+pn(1,3)*ep(3)+
     &pn(1,4)*ep(4)
                 f2=pn(1,1)*ec(1)+pn(1,2)*ec(2)+pn(1,3)*ec(3)+
     &pn(1,4)*ec(4)
                 enew(1)=enew(1)+(f1*cf1+f2*cf2)*ddomeg
                 f1=pn(2,1)*ep(1)+pn(2,2)*ep(2)+pn(2,3)*ep(3)+
     &pn(2,4)*ep(4)
                 f2=pn(2,1)*ec(1)+pn(2,2)*ec(2)+pn(2,3)*ec(3)+
     &pn(2,4)*ec(4)
                 enew(2)=enew(2)+(f1*cf1+f2*cf2)*ddomeg
                 ep(1)=esi0(1,jl,jprim,lprevious)-
     &esi0(1,jr,jprim,lprevious)
                 ep(2)=esi0(2,jl,jprim,lprevious)-
     &esi0(2,jr,jprim,lprevious)
                 ec(1)=esi0(1,jl,jprim,lcurent)-
     &esi0(1,jr,jprim,lcurent)
                 ec(2)=esi0(2,jl,jprim,lcurent)-
     &esi0(2,jr,jprim,lcurent)
                 if((isl.eq.1).and.(isr.eq.1))then
                   ep(3)=esi0(3,jl,jprim,lprevious)+
     &esi0(3,jr,jprim,lprevious)
                   ec(3)=esi0(3,jl,jprim,lcurent)+
     &esi0(3,jr,jprim,lcurent)
                   ep(4)=esi0(4,jl,jprim,lprevious)+
     &esi0(4,jr,jprim,lprevious)
                   ec(4)=esi0(4,jl,jprim,lcurent)+
     &esi0(4,jr,jprim,lcurent)
                 else if((isl.eq.1).and.(isr.eq.-1))then
                   ep(3)=esi0(3,jl,jprim,lprevious)-
     &esi0(3,jr,jprim,lprevious)
                   ec(3)=esi0(3,jl,jprim,lcurent)-
     &esi0(3,jr,jprim,lcurent)
                   ep(4)=esi0(4,jl,jprim,lprevious)-
     &esi0(4,jr,jprim,lprevious)
                   ec(4)=esi0(4,jl,jprim,lcurent)-
     &esi0(4,jr,jprim,lcurent)
                 else if((isl.eq.-1).and.(isr.eq.1))then
                   ep(3)=-esi0(3,jl,jprim,lprevious)+
     &esi0(3,jr,jprim,lprevious)
                   ec(3)=-esi0(3,jl,jprim,lcurent)+
     &esi0(3,jr,jprim,lcurent)
                   ep(4)=-esi0(4,jl,jprim,lprevious)+
     &esi0(4,jr,jprim,lprevious)
                   ec(4)=-esi0(4,jl,jprim,lcurent)+
     &esi0(4,jr,jprim,lcurent)
                 else if((isl.eq.-1).and.(isr.eq.-1))then
                   ep(3)=-esi0(3,jl,jprim,lprevious)-
     &esi0(3,jr,jprim,lprevious)
                   ec(3)=-esi0(3,jl,jprim,lcurent)-
     &esi0(3,jr,jprim,lcurent)
                   ep(4)=-esi0(4,jl,jprim,lprevious)-
     &esi0(4,jr,jprim,lprevious)
                   ec(4)=-esi0(4,jl,jprim,lcurent)-
     &esi0(4,jr,jprim,lcurent)
                 endif
                 f1=pn(3,1)*ep(1)+pn(3,2)*ep(2)+pn(3,3)*ep(3)+
     &pn(3,4)*ep(4)
                 f2=pn(3,1)*ec(1)+pn(3,2)*ec(2)+pn(3,3)*ec(3)+
     &pn(3,4)*ec(4)
                 enew(3)=enew(3)+(f1*cf1+f2*cf2)*ddomeg
                 f1=pn(4,1)*ep(1)+pn(4,2)*ep(2)+pn(4,3)*ep(3)+
     &pn(4,4)*ep(4)
                 f2=pn(4,1)*ec(1)+pn(4,2)*ec(2)+pn(4,3)*ec(3)+
     &pn(4,4)*ec(4)
                 enew(4)=enew(4)+(f1*cf1+f2*cf2)*ddomeg
               endif
            enddo
c backscattering: kfmat=nfi
c phi in > pi
            do n=1,np
               do m=1,np
                  pn(m,n)=wal*fmatrx(m,n,nfi,jprim,i)+
     &wrl*rmatrx(m,n,nfi,jprim,i)+
     &wcl*cmatrx(m,n,nfi,jprim,i)
               enddo
            enddo
            nn=nfi-j+1
            do n=1,np
               ep(n)=esi0(n,nn,jprim,lprevious)
               ec(n)=esi0(n,nn,jprim,lcurent)
            enddo
c Since phi in > pi, must change the sign of esi0(3-4)
            if(np.gt.2)then
              ep(3)=-ep(3)
              ec(3)=-ec(3)
              if(np.gt.3)then
                ep(4)=-ep(4)
                ec(4)=-ec(4)
              endif
            endif
            do m=1,np
               f1=pn(m,1)*ep(1)
               f2=pn(m,1)*ec(1)
               do n=2,np
                  f1=f1+pn(m,n)*ep(n)
                  f2=f2+pn(m,n)*ec(n)
               enddo
               f=f1*cf1
               f=f+f2*cf2
               enew(m)=enew(m)+f*ddomeg
            enddo
80       continue
      end if
      return
      end
C----------------------------------------------------------------------
