c $Header: /usr/people/flittner/radtran/flatpsv/src/sourcer.f,v 1.14 1999/08/16 18:59:08 flittner Exp flittner $
c ---------------------------------------------------------------------

      subroutine sourcer(lcurent,layer,lprevious,i,
     & esi0r,dmu,wal,wrl,wcl,cf1,cf2,Pf0mat,Pr0mat,Pc0mat,nlos,np,enew)

C THE INTEGRAL OF THE DIFFUSE SOURCE FUNCTION (NOT INCLUDING SINGLE SCATTERING)
C OVER TAU IN LAYER LL FOR L.O.S ORIGINATING
C IN LEVEL LCURENT (OBSERVATION LEVEL) AT AN ANGLE THETA I 
C (ANGLE OF L.O.S) and for the m polarization element.
C The integral is for the azimuth fourier component contained in the
C phase matrix arrayss Pf0mat, Pr0mat, and Pc0mat.
C THE SOURCE FUNCTION IS P*I*DOMEGA (INTEGRATED OVER OMEGA)
C SOURCE= MULTIPLE SCATTERING INTENSITY ON ZENITH FROM  
C         THE INTEGRATED SOURCE FUNCTION  AT ITERATION IEND 
C SET THETA' (INPUT) FOR INTEGRATION OVER ALL PHI' (INPUTS) 
C F1 INTENSITY AT LEVEL L-1
C F2 IS INTENSITY AT LEVEL L  
C F IS THE INTEGRAL OF THE INTENSITY ALONG L.O.S BETWEEN LEVEL L-1 AND L
C     (I.E LAYER LL)
c M is the polarization vector element
c
      implicit none
	include 'consts.cmn'
        include 'param.inc'
c variables that are passed
	integer lcurent,layer,lprevious,i,nlos,np
	real*8 Pf0mat(4,4,mlos,mlos),Pr0mat(4,4,mlos,mlos),
     &          Pc0mat(4,4,mlos,mlos),
     &		esi0r(4,mlos,maxnz),dmu(mlos),
     &		cf1,cf2,enew(4),wal,wrl,wcl
c variables that are local
	integer jprim,n,m
	real*8 f2,f1,ep(4),ec(4),pn(4,4),ddomeg
c
c
c
        do m=1,np
	  enew(m)=0.0d0
        enddo
c integrate over theta incident
	do jprim=1,nlos
           ddomeg=df*dmu(jprim)
c I1 and I2 are azimuthally symmetric, so just need average phase function
c with respect to phi.
c Oh, remember that I3 and I4 are zero for this case, so only need to do the
c upper left hand corner of the phase matrix.
c create the multiple scattering matrix
           do n=1,np
              do m=1,np
                 pn(m,n)=wal*Pf0mat(m,n,jprim,i)+
     &wrl*Pr0mat(m,n,jprim,i)+
     &wcl*Pc0mat(m,n,jprim,i)
              enddo
           enddo
c now load the intensities
           do m=1,np
              ep(m)=esi0r(m,jprim,lprevious)
              ec(m)=esi0r(m,jprim,lcurent)
           enddo
c now do P I dw for one input theta direction
           f1=pn(1,1)*(ep(1)*cf1+ec(1)*cf2)
           if(np.gt.1)then
             f1=f1+pn(1,2)*(ep(2)*cf1+ec(2)*cf2)
             f2=pn(2,1)*(ep(1)*cf1+ec(1)*cf2)
             f2=f2+pn(2,2)*(ep(2)*cf1+ec(2)*cf2)
             enew(2)=enew(2)+f2*ddomeg
           endif
           enew(1)=enew(1)+f1*ddomeg
c done with this input theta direction
        enddo
        return
        end
c ---------------------------------------------------------------------
